# Copyright (c) 2024-2025, NVIDIA CORPORATION & AFFILIATES. ALL RIGHTS RESERVED.
#
# SPDX-License-Identifier: Apache-2.0
#
# This code was automatically generated across versions from 11.0.3 to 12.8.0. Do not modify it directly.
# This layer exposes the C header to Cython as-is.

from libc.stdint cimport int64_t, uint64_t
from libc.stdio cimport FILE

from .cycublas cimport cublasStatus_t, cublasComputeType_t, CUBLAS_POINTER_MODE_HOST, CUBLAS_POINTER_MODE_DEVICE
from .cycublas cimport _CUBLASSTATUS_T_INTERNAL_LOADING_ERROR


###############################################################################
# Types (structs, enums, ...)
###############################################################################

# enums
ctypedef enum cublasLtMatmulTile_t "cublasLtMatmulTile_t":
    CUBLASLT_MATMUL_TILE_UNDEFINED "CUBLASLT_MATMUL_TILE_UNDEFINED" = 0
    CUBLASLT_MATMUL_TILE_8x8 "CUBLASLT_MATMUL_TILE_8x8" = 1
    CUBLASLT_MATMUL_TILE_8x16 "CUBLASLT_MATMUL_TILE_8x16" = 2
    CUBLASLT_MATMUL_TILE_16x8 "CUBLASLT_MATMUL_TILE_16x8" = 3
    CUBLASLT_MATMUL_TILE_8x32 "CUBLASLT_MATMUL_TILE_8x32" = 4
    CUBLASLT_MATMUL_TILE_16x16 "CUBLASLT_MATMUL_TILE_16x16" = 5
    CUBLASLT_MATMUL_TILE_32x8 "CUBLASLT_MATMUL_TILE_32x8" = 6
    CUBLASLT_MATMUL_TILE_8x64 "CUBLASLT_MATMUL_TILE_8x64" = 7
    CUBLASLT_MATMUL_TILE_16x32 "CUBLASLT_MATMUL_TILE_16x32" = 8
    CUBLASLT_MATMUL_TILE_32x16 "CUBLASLT_MATMUL_TILE_32x16" = 9
    CUBLASLT_MATMUL_TILE_64x8 "CUBLASLT_MATMUL_TILE_64x8" = 10
    CUBLASLT_MATMUL_TILE_32x32 "CUBLASLT_MATMUL_TILE_32x32" = 11
    CUBLASLT_MATMUL_TILE_32x64 "CUBLASLT_MATMUL_TILE_32x64" = 12
    CUBLASLT_MATMUL_TILE_64x32 "CUBLASLT_MATMUL_TILE_64x32" = 13
    CUBLASLT_MATMUL_TILE_32x128 "CUBLASLT_MATMUL_TILE_32x128" = 14
    CUBLASLT_MATMUL_TILE_64x64 "CUBLASLT_MATMUL_TILE_64x64" = 15
    CUBLASLT_MATMUL_TILE_128x32 "CUBLASLT_MATMUL_TILE_128x32" = 16
    CUBLASLT_MATMUL_TILE_64x128 "CUBLASLT_MATMUL_TILE_64x128" = 17
    CUBLASLT_MATMUL_TILE_128x64 "CUBLASLT_MATMUL_TILE_128x64" = 18
    CUBLASLT_MATMUL_TILE_64x256 "CUBLASLT_MATMUL_TILE_64x256" = 19
    CUBLASLT_MATMUL_TILE_128x128 "CUBLASLT_MATMUL_TILE_128x128" = 20
    CUBLASLT_MATMUL_TILE_256x64 "CUBLASLT_MATMUL_TILE_256x64" = 21
    CUBLASLT_MATMUL_TILE_64x512 "CUBLASLT_MATMUL_TILE_64x512" = 22
    CUBLASLT_MATMUL_TILE_128x256 "CUBLASLT_MATMUL_TILE_128x256" = 23
    CUBLASLT_MATMUL_TILE_256x128 "CUBLASLT_MATMUL_TILE_256x128" = 24
    CUBLASLT_MATMUL_TILE_512x64 "CUBLASLT_MATMUL_TILE_512x64" = 25
    CUBLASLT_MATMUL_TILE_64x96 "CUBLASLT_MATMUL_TILE_64x96" = 26
    CUBLASLT_MATMUL_TILE_96x64 "CUBLASLT_MATMUL_TILE_96x64" = 27
    CUBLASLT_MATMUL_TILE_96x128 "CUBLASLT_MATMUL_TILE_96x128" = 28
    CUBLASLT_MATMUL_TILE_128x160 "CUBLASLT_MATMUL_TILE_128x160" = 29
    CUBLASLT_MATMUL_TILE_160x128 "CUBLASLT_MATMUL_TILE_160x128" = 30
    CUBLASLT_MATMUL_TILE_192x128 "CUBLASLT_MATMUL_TILE_192x128" = 31
    CUBLASLT_MATMUL_TILE_128x192 "CUBLASLT_MATMUL_TILE_128x192" = 32
    CUBLASLT_MATMUL_TILE_128x96 "CUBLASLT_MATMUL_TILE_128x96" = 33
    CUBLASLT_MATMUL_TILE_32x256 "CUBLASLT_MATMUL_TILE_32x256" = 34
    CUBLASLT_MATMUL_TILE_256x32 "CUBLASLT_MATMUL_TILE_256x32" = 35
    CUBLASLT_MATMUL_TILE_8x128 "CUBLASLT_MATMUL_TILE_8x128" = 36
    CUBLASLT_MATMUL_TILE_8x192 "CUBLASLT_MATMUL_TILE_8x192" = 37
    CUBLASLT_MATMUL_TILE_8x256 "CUBLASLT_MATMUL_TILE_8x256" = 38
    CUBLASLT_MATMUL_TILE_8x320 "CUBLASLT_MATMUL_TILE_8x320" = 39
    CUBLASLT_MATMUL_TILE_8x384 "CUBLASLT_MATMUL_TILE_8x384" = 40
    CUBLASLT_MATMUL_TILE_8x448 "CUBLASLT_MATMUL_TILE_8x448" = 41
    CUBLASLT_MATMUL_TILE_8x512 "CUBLASLT_MATMUL_TILE_8x512" = 42
    CUBLASLT_MATMUL_TILE_8x576 "CUBLASLT_MATMUL_TILE_8x576" = 43
    CUBLASLT_MATMUL_TILE_8x640 "CUBLASLT_MATMUL_TILE_8x640" = 44
    CUBLASLT_MATMUL_TILE_8x704 "CUBLASLT_MATMUL_TILE_8x704" = 45
    CUBLASLT_MATMUL_TILE_8x768 "CUBLASLT_MATMUL_TILE_8x768" = 46
    CUBLASLT_MATMUL_TILE_16x64 "CUBLASLT_MATMUL_TILE_16x64" = 47
    CUBLASLT_MATMUL_TILE_16x128 "CUBLASLT_MATMUL_TILE_16x128" = 48
    CUBLASLT_MATMUL_TILE_16x192 "CUBLASLT_MATMUL_TILE_16x192" = 49
    CUBLASLT_MATMUL_TILE_16x256 "CUBLASLT_MATMUL_TILE_16x256" = 50
    CUBLASLT_MATMUL_TILE_16x320 "CUBLASLT_MATMUL_TILE_16x320" = 51
    CUBLASLT_MATMUL_TILE_16x384 "CUBLASLT_MATMUL_TILE_16x384" = 52
    CUBLASLT_MATMUL_TILE_16x448 "CUBLASLT_MATMUL_TILE_16x448" = 53
    CUBLASLT_MATMUL_TILE_16x512 "CUBLASLT_MATMUL_TILE_16x512" = 54
    CUBLASLT_MATMUL_TILE_16x576 "CUBLASLT_MATMUL_TILE_16x576" = 55
    CUBLASLT_MATMUL_TILE_16x640 "CUBLASLT_MATMUL_TILE_16x640" = 56
    CUBLASLT_MATMUL_TILE_16x704 "CUBLASLT_MATMUL_TILE_16x704" = 57
    CUBLASLT_MATMUL_TILE_16x768 "CUBLASLT_MATMUL_TILE_16x768" = 58
    CUBLASLT_MATMUL_TILE_24x64 "CUBLASLT_MATMUL_TILE_24x64" = 59
    CUBLASLT_MATMUL_TILE_24x128 "CUBLASLT_MATMUL_TILE_24x128" = 60
    CUBLASLT_MATMUL_TILE_24x192 "CUBLASLT_MATMUL_TILE_24x192" = 61
    CUBLASLT_MATMUL_TILE_24x256 "CUBLASLT_MATMUL_TILE_24x256" = 62
    CUBLASLT_MATMUL_TILE_24x320 "CUBLASLT_MATMUL_TILE_24x320" = 63
    CUBLASLT_MATMUL_TILE_24x384 "CUBLASLT_MATMUL_TILE_24x384" = 64
    CUBLASLT_MATMUL_TILE_24x448 "CUBLASLT_MATMUL_TILE_24x448" = 65
    CUBLASLT_MATMUL_TILE_24x512 "CUBLASLT_MATMUL_TILE_24x512" = 66
    CUBLASLT_MATMUL_TILE_24x576 "CUBLASLT_MATMUL_TILE_24x576" = 67
    CUBLASLT_MATMUL_TILE_24x640 "CUBLASLT_MATMUL_TILE_24x640" = 68
    CUBLASLT_MATMUL_TILE_24x704 "CUBLASLT_MATMUL_TILE_24x704" = 69
    CUBLASLT_MATMUL_TILE_24x768 "CUBLASLT_MATMUL_TILE_24x768" = 70
    CUBLASLT_MATMUL_TILE_32x192 "CUBLASLT_MATMUL_TILE_32x192" = 71
    CUBLASLT_MATMUL_TILE_32x320 "CUBLASLT_MATMUL_TILE_32x320" = 72
    CUBLASLT_MATMUL_TILE_32x384 "CUBLASLT_MATMUL_TILE_32x384" = 73
    CUBLASLT_MATMUL_TILE_32x448 "CUBLASLT_MATMUL_TILE_32x448" = 74
    CUBLASLT_MATMUL_TILE_32x512 "CUBLASLT_MATMUL_TILE_32x512" = 75
    CUBLASLT_MATMUL_TILE_32x576 "CUBLASLT_MATMUL_TILE_32x576" = 76
    CUBLASLT_MATMUL_TILE_32x640 "CUBLASLT_MATMUL_TILE_32x640" = 77
    CUBLASLT_MATMUL_TILE_32x704 "CUBLASLT_MATMUL_TILE_32x704" = 78
    CUBLASLT_MATMUL_TILE_32x768 "CUBLASLT_MATMUL_TILE_32x768" = 79
    CUBLASLT_MATMUL_TILE_40x64 "CUBLASLT_MATMUL_TILE_40x64" = 80
    CUBLASLT_MATMUL_TILE_40x128 "CUBLASLT_MATMUL_TILE_40x128" = 81
    CUBLASLT_MATMUL_TILE_40x192 "CUBLASLT_MATMUL_TILE_40x192" = 82
    CUBLASLT_MATMUL_TILE_40x256 "CUBLASLT_MATMUL_TILE_40x256" = 83
    CUBLASLT_MATMUL_TILE_40x320 "CUBLASLT_MATMUL_TILE_40x320" = 84
    CUBLASLT_MATMUL_TILE_40x384 "CUBLASLT_MATMUL_TILE_40x384" = 85
    CUBLASLT_MATMUL_TILE_40x448 "CUBLASLT_MATMUL_TILE_40x448" = 86
    CUBLASLT_MATMUL_TILE_40x512 "CUBLASLT_MATMUL_TILE_40x512" = 87
    CUBLASLT_MATMUL_TILE_40x576 "CUBLASLT_MATMUL_TILE_40x576" = 88
    CUBLASLT_MATMUL_TILE_40x640 "CUBLASLT_MATMUL_TILE_40x640" = 89
    CUBLASLT_MATMUL_TILE_40x704 "CUBLASLT_MATMUL_TILE_40x704" = 90
    CUBLASLT_MATMUL_TILE_40x768 "CUBLASLT_MATMUL_TILE_40x768" = 91
    CUBLASLT_MATMUL_TILE_48x64 "CUBLASLT_MATMUL_TILE_48x64" = 92
    CUBLASLT_MATMUL_TILE_48x128 "CUBLASLT_MATMUL_TILE_48x128" = 93
    CUBLASLT_MATMUL_TILE_48x192 "CUBLASLT_MATMUL_TILE_48x192" = 94
    CUBLASLT_MATMUL_TILE_48x256 "CUBLASLT_MATMUL_TILE_48x256" = 95
    CUBLASLT_MATMUL_TILE_48x320 "CUBLASLT_MATMUL_TILE_48x320" = 96
    CUBLASLT_MATMUL_TILE_48x384 "CUBLASLT_MATMUL_TILE_48x384" = 97
    CUBLASLT_MATMUL_TILE_48x448 "CUBLASLT_MATMUL_TILE_48x448" = 98
    CUBLASLT_MATMUL_TILE_48x512 "CUBLASLT_MATMUL_TILE_48x512" = 99
    CUBLASLT_MATMUL_TILE_48x576 "CUBLASLT_MATMUL_TILE_48x576" = 100
    CUBLASLT_MATMUL_TILE_48x640 "CUBLASLT_MATMUL_TILE_48x640" = 101
    CUBLASLT_MATMUL_TILE_48x704 "CUBLASLT_MATMUL_TILE_48x704" = 102
    CUBLASLT_MATMUL_TILE_48x768 "CUBLASLT_MATMUL_TILE_48x768" = 103
    CUBLASLT_MATMUL_TILE_56x64 "CUBLASLT_MATMUL_TILE_56x64" = 104
    CUBLASLT_MATMUL_TILE_56x128 "CUBLASLT_MATMUL_TILE_56x128" = 105
    CUBLASLT_MATMUL_TILE_56x192 "CUBLASLT_MATMUL_TILE_56x192" = 106
    CUBLASLT_MATMUL_TILE_56x256 "CUBLASLT_MATMUL_TILE_56x256" = 107
    CUBLASLT_MATMUL_TILE_56x320 "CUBLASLT_MATMUL_TILE_56x320" = 108
    CUBLASLT_MATMUL_TILE_56x384 "CUBLASLT_MATMUL_TILE_56x384" = 109
    CUBLASLT_MATMUL_TILE_56x448 "CUBLASLT_MATMUL_TILE_56x448" = 110
    CUBLASLT_MATMUL_TILE_56x512 "CUBLASLT_MATMUL_TILE_56x512" = 111
    CUBLASLT_MATMUL_TILE_56x576 "CUBLASLT_MATMUL_TILE_56x576" = 112
    CUBLASLT_MATMUL_TILE_56x640 "CUBLASLT_MATMUL_TILE_56x640" = 113
    CUBLASLT_MATMUL_TILE_56x704 "CUBLASLT_MATMUL_TILE_56x704" = 114
    CUBLASLT_MATMUL_TILE_56x768 "CUBLASLT_MATMUL_TILE_56x768" = 115
    CUBLASLT_MATMUL_TILE_64x192 "CUBLASLT_MATMUL_TILE_64x192" = 116
    CUBLASLT_MATMUL_TILE_64x320 "CUBLASLT_MATMUL_TILE_64x320" = 117
    CUBLASLT_MATMUL_TILE_64x384 "CUBLASLT_MATMUL_TILE_64x384" = 118
    CUBLASLT_MATMUL_TILE_64x448 "CUBLASLT_MATMUL_TILE_64x448" = 119
    CUBLASLT_MATMUL_TILE_64x576 "CUBLASLT_MATMUL_TILE_64x576" = 120
    CUBLASLT_MATMUL_TILE_64x640 "CUBLASLT_MATMUL_TILE_64x640" = 121
    CUBLASLT_MATMUL_TILE_64x704 "CUBLASLT_MATMUL_TILE_64x704" = 122
    CUBLASLT_MATMUL_TILE_64x768 "CUBLASLT_MATMUL_TILE_64x768" = 123
    CUBLASLT_MATMUL_TILE_72x64 "CUBLASLT_MATMUL_TILE_72x64" = 124
    CUBLASLT_MATMUL_TILE_72x128 "CUBLASLT_MATMUL_TILE_72x128" = 125
    CUBLASLT_MATMUL_TILE_72x192 "CUBLASLT_MATMUL_TILE_72x192" = 126
    CUBLASLT_MATMUL_TILE_72x256 "CUBLASLT_MATMUL_TILE_72x256" = 127
    CUBLASLT_MATMUL_TILE_72x320 "CUBLASLT_MATMUL_TILE_72x320" = 128
    CUBLASLT_MATMUL_TILE_72x384 "CUBLASLT_MATMUL_TILE_72x384" = 129
    CUBLASLT_MATMUL_TILE_72x448 "CUBLASLT_MATMUL_TILE_72x448" = 130
    CUBLASLT_MATMUL_TILE_72x512 "CUBLASLT_MATMUL_TILE_72x512" = 131
    CUBLASLT_MATMUL_TILE_72x576 "CUBLASLT_MATMUL_TILE_72x576" = 132
    CUBLASLT_MATMUL_TILE_72x640 "CUBLASLT_MATMUL_TILE_72x640" = 133
    CUBLASLT_MATMUL_TILE_80x64 "CUBLASLT_MATMUL_TILE_80x64" = 134
    CUBLASLT_MATMUL_TILE_80x128 "CUBLASLT_MATMUL_TILE_80x128" = 135
    CUBLASLT_MATMUL_TILE_80x192 "CUBLASLT_MATMUL_TILE_80x192" = 136
    CUBLASLT_MATMUL_TILE_80x256 "CUBLASLT_MATMUL_TILE_80x256" = 137
    CUBLASLT_MATMUL_TILE_80x320 "CUBLASLT_MATMUL_TILE_80x320" = 138
    CUBLASLT_MATMUL_TILE_80x384 "CUBLASLT_MATMUL_TILE_80x384" = 139
    CUBLASLT_MATMUL_TILE_80x448 "CUBLASLT_MATMUL_TILE_80x448" = 140
    CUBLASLT_MATMUL_TILE_80x512 "CUBLASLT_MATMUL_TILE_80x512" = 141
    CUBLASLT_MATMUL_TILE_80x576 "CUBLASLT_MATMUL_TILE_80x576" = 142
    CUBLASLT_MATMUL_TILE_88x64 "CUBLASLT_MATMUL_TILE_88x64" = 143
    CUBLASLT_MATMUL_TILE_88x128 "CUBLASLT_MATMUL_TILE_88x128" = 144
    CUBLASLT_MATMUL_TILE_88x192 "CUBLASLT_MATMUL_TILE_88x192" = 145
    CUBLASLT_MATMUL_TILE_88x256 "CUBLASLT_MATMUL_TILE_88x256" = 146
    CUBLASLT_MATMUL_TILE_88x320 "CUBLASLT_MATMUL_TILE_88x320" = 147
    CUBLASLT_MATMUL_TILE_88x384 "CUBLASLT_MATMUL_TILE_88x384" = 148
    CUBLASLT_MATMUL_TILE_88x448 "CUBLASLT_MATMUL_TILE_88x448" = 149
    CUBLASLT_MATMUL_TILE_88x512 "CUBLASLT_MATMUL_TILE_88x512" = 150
    CUBLASLT_MATMUL_TILE_96x192 "CUBLASLT_MATMUL_TILE_96x192" = 151
    CUBLASLT_MATMUL_TILE_96x256 "CUBLASLT_MATMUL_TILE_96x256" = 152
    CUBLASLT_MATMUL_TILE_96x320 "CUBLASLT_MATMUL_TILE_96x320" = 153
    CUBLASLT_MATMUL_TILE_96x384 "CUBLASLT_MATMUL_TILE_96x384" = 154
    CUBLASLT_MATMUL_TILE_96x448 "CUBLASLT_MATMUL_TILE_96x448" = 155
    CUBLASLT_MATMUL_TILE_96x512 "CUBLASLT_MATMUL_TILE_96x512" = 156
    CUBLASLT_MATMUL_TILE_104x64 "CUBLASLT_MATMUL_TILE_104x64" = 157
    CUBLASLT_MATMUL_TILE_104x128 "CUBLASLT_MATMUL_TILE_104x128" = 158
    CUBLASLT_MATMUL_TILE_104x192 "CUBLASLT_MATMUL_TILE_104x192" = 159
    CUBLASLT_MATMUL_TILE_104x256 "CUBLASLT_MATMUL_TILE_104x256" = 160
    CUBLASLT_MATMUL_TILE_104x320 "CUBLASLT_MATMUL_TILE_104x320" = 161
    CUBLASLT_MATMUL_TILE_104x384 "CUBLASLT_MATMUL_TILE_104x384" = 162
    CUBLASLT_MATMUL_TILE_104x448 "CUBLASLT_MATMUL_TILE_104x448" = 163
    CUBLASLT_MATMUL_TILE_112x64 "CUBLASLT_MATMUL_TILE_112x64" = 164
    CUBLASLT_MATMUL_TILE_112x128 "CUBLASLT_MATMUL_TILE_112x128" = 165
    CUBLASLT_MATMUL_TILE_112x192 "CUBLASLT_MATMUL_TILE_112x192" = 166
    CUBLASLT_MATMUL_TILE_112x256 "CUBLASLT_MATMUL_TILE_112x256" = 167
    CUBLASLT_MATMUL_TILE_112x320 "CUBLASLT_MATMUL_TILE_112x320" = 168
    CUBLASLT_MATMUL_TILE_112x384 "CUBLASLT_MATMUL_TILE_112x384" = 169
    CUBLASLT_MATMUL_TILE_120x64 "CUBLASLT_MATMUL_TILE_120x64" = 170
    CUBLASLT_MATMUL_TILE_120x128 "CUBLASLT_MATMUL_TILE_120x128" = 171
    CUBLASLT_MATMUL_TILE_120x192 "CUBLASLT_MATMUL_TILE_120x192" = 172
    CUBLASLT_MATMUL_TILE_120x256 "CUBLASLT_MATMUL_TILE_120x256" = 173
    CUBLASLT_MATMUL_TILE_120x320 "CUBLASLT_MATMUL_TILE_120x320" = 174
    CUBLASLT_MATMUL_TILE_120x384 "CUBLASLT_MATMUL_TILE_120x384" = 175
    CUBLASLT_MATMUL_TILE_128x320 "CUBLASLT_MATMUL_TILE_128x320" = 176
    CUBLASLT_MATMUL_TILE_128x384 "CUBLASLT_MATMUL_TILE_128x384" = 177
    CUBLASLT_MATMUL_TILE_136x64 "CUBLASLT_MATMUL_TILE_136x64" = 178
    CUBLASLT_MATMUL_TILE_136x128 "CUBLASLT_MATMUL_TILE_136x128" = 179
    CUBLASLT_MATMUL_TILE_136x192 "CUBLASLT_MATMUL_TILE_136x192" = 180
    CUBLASLT_MATMUL_TILE_136x256 "CUBLASLT_MATMUL_TILE_136x256" = 181
    CUBLASLT_MATMUL_TILE_136x320 "CUBLASLT_MATMUL_TILE_136x320" = 182
    CUBLASLT_MATMUL_TILE_144x64 "CUBLASLT_MATMUL_TILE_144x64" = 183
    CUBLASLT_MATMUL_TILE_144x128 "CUBLASLT_MATMUL_TILE_144x128" = 184
    CUBLASLT_MATMUL_TILE_144x192 "CUBLASLT_MATMUL_TILE_144x192" = 185
    CUBLASLT_MATMUL_TILE_144x256 "CUBLASLT_MATMUL_TILE_144x256" = 186
    CUBLASLT_MATMUL_TILE_144x320 "CUBLASLT_MATMUL_TILE_144x320" = 187
    CUBLASLT_MATMUL_TILE_152x64 "CUBLASLT_MATMUL_TILE_152x64" = 188
    CUBLASLT_MATMUL_TILE_152x128 "CUBLASLT_MATMUL_TILE_152x128" = 189
    CUBLASLT_MATMUL_TILE_152x192 "CUBLASLT_MATMUL_TILE_152x192" = 190
    CUBLASLT_MATMUL_TILE_152x256 "CUBLASLT_MATMUL_TILE_152x256" = 191
    CUBLASLT_MATMUL_TILE_152x320 "CUBLASLT_MATMUL_TILE_152x320" = 192
    CUBLASLT_MATMUL_TILE_160x64 "CUBLASLT_MATMUL_TILE_160x64" = 193
    CUBLASLT_MATMUL_TILE_160x192 "CUBLASLT_MATMUL_TILE_160x192" = 194
    CUBLASLT_MATMUL_TILE_160x256 "CUBLASLT_MATMUL_TILE_160x256" = 195
    CUBLASLT_MATMUL_TILE_168x64 "CUBLASLT_MATMUL_TILE_168x64" = 196
    CUBLASLT_MATMUL_TILE_168x128 "CUBLASLT_MATMUL_TILE_168x128" = 197
    CUBLASLT_MATMUL_TILE_168x192 "CUBLASLT_MATMUL_TILE_168x192" = 198
    CUBLASLT_MATMUL_TILE_168x256 "CUBLASLT_MATMUL_TILE_168x256" = 199
    CUBLASLT_MATMUL_TILE_176x64 "CUBLASLT_MATMUL_TILE_176x64" = 200
    CUBLASLT_MATMUL_TILE_176x128 "CUBLASLT_MATMUL_TILE_176x128" = 201
    CUBLASLT_MATMUL_TILE_176x192 "CUBLASLT_MATMUL_TILE_176x192" = 202
    CUBLASLT_MATMUL_TILE_176x256 "CUBLASLT_MATMUL_TILE_176x256" = 203
    CUBLASLT_MATMUL_TILE_184x64 "CUBLASLT_MATMUL_TILE_184x64" = 204
    CUBLASLT_MATMUL_TILE_184x128 "CUBLASLT_MATMUL_TILE_184x128" = 205
    CUBLASLT_MATMUL_TILE_184x192 "CUBLASLT_MATMUL_TILE_184x192" = 206
    CUBLASLT_MATMUL_TILE_184x256 "CUBLASLT_MATMUL_TILE_184x256" = 207
    CUBLASLT_MATMUL_TILE_192x64 "CUBLASLT_MATMUL_TILE_192x64" = 208
    CUBLASLT_MATMUL_TILE_192x192 "CUBLASLT_MATMUL_TILE_192x192" = 209
    CUBLASLT_MATMUL_TILE_192x256 "CUBLASLT_MATMUL_TILE_192x256" = 210
    CUBLASLT_MATMUL_TILE_200x64 "CUBLASLT_MATMUL_TILE_200x64" = 211
    CUBLASLT_MATMUL_TILE_200x128 "CUBLASLT_MATMUL_TILE_200x128" = 212
    CUBLASLT_MATMUL_TILE_200x192 "CUBLASLT_MATMUL_TILE_200x192" = 213
    CUBLASLT_MATMUL_TILE_208x64 "CUBLASLT_MATMUL_TILE_208x64" = 214
    CUBLASLT_MATMUL_TILE_208x128 "CUBLASLT_MATMUL_TILE_208x128" = 215
    CUBLASLT_MATMUL_TILE_208x192 "CUBLASLT_MATMUL_TILE_208x192" = 216
    CUBLASLT_MATMUL_TILE_216x64 "CUBLASLT_MATMUL_TILE_216x64" = 217
    CUBLASLT_MATMUL_TILE_216x128 "CUBLASLT_MATMUL_TILE_216x128" = 218
    CUBLASLT_MATMUL_TILE_216x192 "CUBLASLT_MATMUL_TILE_216x192" = 219
    CUBLASLT_MATMUL_TILE_224x64 "CUBLASLT_MATMUL_TILE_224x64" = 220
    CUBLASLT_MATMUL_TILE_224x128 "CUBLASLT_MATMUL_TILE_224x128" = 221
    CUBLASLT_MATMUL_TILE_224x192 "CUBLASLT_MATMUL_TILE_224x192" = 222
    CUBLASLT_MATMUL_TILE_232x64 "CUBLASLT_MATMUL_TILE_232x64" = 223
    CUBLASLT_MATMUL_TILE_232x128 "CUBLASLT_MATMUL_TILE_232x128" = 224
    CUBLASLT_MATMUL_TILE_232x192 "CUBLASLT_MATMUL_TILE_232x192" = 225
    CUBLASLT_MATMUL_TILE_240x64 "CUBLASLT_MATMUL_TILE_240x64" = 226
    CUBLASLT_MATMUL_TILE_240x128 "CUBLASLT_MATMUL_TILE_240x128" = 227
    CUBLASLT_MATMUL_TILE_240x192 "CUBLASLT_MATMUL_TILE_240x192" = 228
    CUBLASLT_MATMUL_TILE_248x64 "CUBLASLT_MATMUL_TILE_248x64" = 229
    CUBLASLT_MATMUL_TILE_248x128 "CUBLASLT_MATMUL_TILE_248x128" = 230
    CUBLASLT_MATMUL_TILE_248x192 "CUBLASLT_MATMUL_TILE_248x192" = 231
    CUBLASLT_MATMUL_TILE_256x192 "CUBLASLT_MATMUL_TILE_256x192" = 232
    CUBLASLT_MATMUL_TILE_264x64 "CUBLASLT_MATMUL_TILE_264x64" = 233
    CUBLASLT_MATMUL_TILE_264x128 "CUBLASLT_MATMUL_TILE_264x128" = 234
    CUBLASLT_MATMUL_TILE_272x64 "CUBLASLT_MATMUL_TILE_272x64" = 235
    CUBLASLT_MATMUL_TILE_272x128 "CUBLASLT_MATMUL_TILE_272x128" = 236
    CUBLASLT_MATMUL_TILE_280x64 "CUBLASLT_MATMUL_TILE_280x64" = 237
    CUBLASLT_MATMUL_TILE_280x128 "CUBLASLT_MATMUL_TILE_280x128" = 238
    CUBLASLT_MATMUL_TILE_288x64 "CUBLASLT_MATMUL_TILE_288x64" = 239
    CUBLASLT_MATMUL_TILE_288x128 "CUBLASLT_MATMUL_TILE_288x128" = 240
    CUBLASLT_MATMUL_TILE_296x64 "CUBLASLT_MATMUL_TILE_296x64" = 241
    CUBLASLT_MATMUL_TILE_296x128 "CUBLASLT_MATMUL_TILE_296x128" = 242
    CUBLASLT_MATMUL_TILE_304x64 "CUBLASLT_MATMUL_TILE_304x64" = 243
    CUBLASLT_MATMUL_TILE_304x128 "CUBLASLT_MATMUL_TILE_304x128" = 244
    CUBLASLT_MATMUL_TILE_312x64 "CUBLASLT_MATMUL_TILE_312x64" = 245
    CUBLASLT_MATMUL_TILE_312x128 "CUBLASLT_MATMUL_TILE_312x128" = 246
    CUBLASLT_MATMUL_TILE_320x64 "CUBLASLT_MATMUL_TILE_320x64" = 247
    CUBLASLT_MATMUL_TILE_320x128 "CUBLASLT_MATMUL_TILE_320x128" = 248
    CUBLASLT_MATMUL_TILE_328x64 "CUBLASLT_MATMUL_TILE_328x64" = 249
    CUBLASLT_MATMUL_TILE_328x128 "CUBLASLT_MATMUL_TILE_328x128" = 250
    CUBLASLT_MATMUL_TILE_336x64 "CUBLASLT_MATMUL_TILE_336x64" = 251
    CUBLASLT_MATMUL_TILE_336x128 "CUBLASLT_MATMUL_TILE_336x128" = 252
    CUBLASLT_MATMUL_TILE_344x64 "CUBLASLT_MATMUL_TILE_344x64" = 253
    CUBLASLT_MATMUL_TILE_344x128 "CUBLASLT_MATMUL_TILE_344x128" = 254
    CUBLASLT_MATMUL_TILE_352x64 "CUBLASLT_MATMUL_TILE_352x64" = 255
    CUBLASLT_MATMUL_TILE_352x128 "CUBLASLT_MATMUL_TILE_352x128" = 256
    CUBLASLT_MATMUL_TILE_360x64 "CUBLASLT_MATMUL_TILE_360x64" = 257
    CUBLASLT_MATMUL_TILE_360x128 "CUBLASLT_MATMUL_TILE_360x128" = 258
    CUBLASLT_MATMUL_TILE_368x64 "CUBLASLT_MATMUL_TILE_368x64" = 259
    CUBLASLT_MATMUL_TILE_368x128 "CUBLASLT_MATMUL_TILE_368x128" = 260
    CUBLASLT_MATMUL_TILE_376x64 "CUBLASLT_MATMUL_TILE_376x64" = 261
    CUBLASLT_MATMUL_TILE_376x128 "CUBLASLT_MATMUL_TILE_376x128" = 262
    CUBLASLT_MATMUL_TILE_384x64 "CUBLASLT_MATMUL_TILE_384x64" = 263
    CUBLASLT_MATMUL_TILE_384x128 "CUBLASLT_MATMUL_TILE_384x128" = 264
    CUBLASLT_MATMUL_TILE_392x64 "CUBLASLT_MATMUL_TILE_392x64" = 265
    CUBLASLT_MATMUL_TILE_400x64 "CUBLASLT_MATMUL_TILE_400x64" = 266
    CUBLASLT_MATMUL_TILE_408x64 "CUBLASLT_MATMUL_TILE_408x64" = 267
    CUBLASLT_MATMUL_TILE_416x64 "CUBLASLT_MATMUL_TILE_416x64" = 268
    CUBLASLT_MATMUL_TILE_424x64 "CUBLASLT_MATMUL_TILE_424x64" = 269
    CUBLASLT_MATMUL_TILE_432x64 "CUBLASLT_MATMUL_TILE_432x64" = 270
    CUBLASLT_MATMUL_TILE_440x64 "CUBLASLT_MATMUL_TILE_440x64" = 271
    CUBLASLT_MATMUL_TILE_448x64 "CUBLASLT_MATMUL_TILE_448x64" = 272
    CUBLASLT_MATMUL_TILE_456x64 "CUBLASLT_MATMUL_TILE_456x64" = 273
    CUBLASLT_MATMUL_TILE_464x64 "CUBLASLT_MATMUL_TILE_464x64" = 274
    CUBLASLT_MATMUL_TILE_472x64 "CUBLASLT_MATMUL_TILE_472x64" = 275
    CUBLASLT_MATMUL_TILE_480x64 "CUBLASLT_MATMUL_TILE_480x64" = 276
    CUBLASLT_MATMUL_TILE_488x64 "CUBLASLT_MATMUL_TILE_488x64" = 277
    CUBLASLT_MATMUL_TILE_496x64 "CUBLASLT_MATMUL_TILE_496x64" = 278
    CUBLASLT_MATMUL_TILE_504x64 "CUBLASLT_MATMUL_TILE_504x64" = 279
    CUBLASLT_MATMUL_TILE_520x64 "CUBLASLT_MATMUL_TILE_520x64" = 280
    CUBLASLT_MATMUL_TILE_528x64 "CUBLASLT_MATMUL_TILE_528x64" = 281
    CUBLASLT_MATMUL_TILE_536x64 "CUBLASLT_MATMUL_TILE_536x64" = 282
    CUBLASLT_MATMUL_TILE_544x64 "CUBLASLT_MATMUL_TILE_544x64" = 283
    CUBLASLT_MATMUL_TILE_552x64 "CUBLASLT_MATMUL_TILE_552x64" = 284
    CUBLASLT_MATMUL_TILE_560x64 "CUBLASLT_MATMUL_TILE_560x64" = 285
    CUBLASLT_MATMUL_TILE_568x64 "CUBLASLT_MATMUL_TILE_568x64" = 286
    CUBLASLT_MATMUL_TILE_576x64 "CUBLASLT_MATMUL_TILE_576x64" = 287
    CUBLASLT_MATMUL_TILE_584x64 "CUBLASLT_MATMUL_TILE_584x64" = 288
    CUBLASLT_MATMUL_TILE_592x64 "CUBLASLT_MATMUL_TILE_592x64" = 289
    CUBLASLT_MATMUL_TILE_600x64 "CUBLASLT_MATMUL_TILE_600x64" = 290
    CUBLASLT_MATMUL_TILE_608x64 "CUBLASLT_MATMUL_TILE_608x64" = 291
    CUBLASLT_MATMUL_TILE_616x64 "CUBLASLT_MATMUL_TILE_616x64" = 292
    CUBLASLT_MATMUL_TILE_624x64 "CUBLASLT_MATMUL_TILE_624x64" = 293
    CUBLASLT_MATMUL_TILE_632x64 "CUBLASLT_MATMUL_TILE_632x64" = 294
    CUBLASLT_MATMUL_TILE_640x64 "CUBLASLT_MATMUL_TILE_640x64" = 295
    CUBLASLT_MATMUL_TILE_648x64 "CUBLASLT_MATMUL_TILE_648x64" = 296
    CUBLASLT_MATMUL_TILE_656x64 "CUBLASLT_MATMUL_TILE_656x64" = 297
    CUBLASLT_MATMUL_TILE_664x64 "CUBLASLT_MATMUL_TILE_664x64" = 298
    CUBLASLT_MATMUL_TILE_672x64 "CUBLASLT_MATMUL_TILE_672x64" = 299
    CUBLASLT_MATMUL_TILE_680x64 "CUBLASLT_MATMUL_TILE_680x64" = 300
    CUBLASLT_MATMUL_TILE_688x64 "CUBLASLT_MATMUL_TILE_688x64" = 301
    CUBLASLT_MATMUL_TILE_696x64 "CUBLASLT_MATMUL_TILE_696x64" = 302
    CUBLASLT_MATMUL_TILE_704x64 "CUBLASLT_MATMUL_TILE_704x64" = 303
    CUBLASLT_MATMUL_TILE_712x64 "CUBLASLT_MATMUL_TILE_712x64" = 304
    CUBLASLT_MATMUL_TILE_720x64 "CUBLASLT_MATMUL_TILE_720x64" = 305
    CUBLASLT_MATMUL_TILE_728x64 "CUBLASLT_MATMUL_TILE_728x64" = 306
    CUBLASLT_MATMUL_TILE_736x64 "CUBLASLT_MATMUL_TILE_736x64" = 307
    CUBLASLT_MATMUL_TILE_744x64 "CUBLASLT_MATMUL_TILE_744x64" = 308
    CUBLASLT_MATMUL_TILE_752x64 "CUBLASLT_MATMUL_TILE_752x64" = 309
    CUBLASLT_MATMUL_TILE_760x64 "CUBLASLT_MATMUL_TILE_760x64" = 310
    CUBLASLT_MATMUL_TILE_768x64 "CUBLASLT_MATMUL_TILE_768x64" = 311
    CUBLASLT_MATMUL_TILE_64x16 "CUBLASLT_MATMUL_TILE_64x16" = 312
    CUBLASLT_MATMUL_TILE_64x24 "CUBLASLT_MATMUL_TILE_64x24" = 313
    CUBLASLT_MATMUL_TILE_64x40 "CUBLASLT_MATMUL_TILE_64x40" = 314
    CUBLASLT_MATMUL_TILE_64x48 "CUBLASLT_MATMUL_TILE_64x48" = 315
    CUBLASLT_MATMUL_TILE_64x56 "CUBLASLT_MATMUL_TILE_64x56" = 316
    CUBLASLT_MATMUL_TILE_64x72 "CUBLASLT_MATMUL_TILE_64x72" = 317
    CUBLASLT_MATMUL_TILE_64x80 "CUBLASLT_MATMUL_TILE_64x80" = 318
    CUBLASLT_MATMUL_TILE_64x88 "CUBLASLT_MATMUL_TILE_64x88" = 319
    CUBLASLT_MATMUL_TILE_64x104 "CUBLASLT_MATMUL_TILE_64x104" = 320
    CUBLASLT_MATMUL_TILE_64x112 "CUBLASLT_MATMUL_TILE_64x112" = 321
    CUBLASLT_MATMUL_TILE_64x120 "CUBLASLT_MATMUL_TILE_64x120" = 322
    CUBLASLT_MATMUL_TILE_64x136 "CUBLASLT_MATMUL_TILE_64x136" = 323
    CUBLASLT_MATMUL_TILE_64x144 "CUBLASLT_MATMUL_TILE_64x144" = 324
    CUBLASLT_MATMUL_TILE_64x152 "CUBLASLT_MATMUL_TILE_64x152" = 325
    CUBLASLT_MATMUL_TILE_64x160 "CUBLASLT_MATMUL_TILE_64x160" = 326
    CUBLASLT_MATMUL_TILE_64x168 "CUBLASLT_MATMUL_TILE_64x168" = 327
    CUBLASLT_MATMUL_TILE_64x176 "CUBLASLT_MATMUL_TILE_64x176" = 328
    CUBLASLT_MATMUL_TILE_64x184 "CUBLASLT_MATMUL_TILE_64x184" = 329
    CUBLASLT_MATMUL_TILE_64x200 "CUBLASLT_MATMUL_TILE_64x200" = 330
    CUBLASLT_MATMUL_TILE_64x208 "CUBLASLT_MATMUL_TILE_64x208" = 331
    CUBLASLT_MATMUL_TILE_64x216 "CUBLASLT_MATMUL_TILE_64x216" = 332
    CUBLASLT_MATMUL_TILE_64x224 "CUBLASLT_MATMUL_TILE_64x224" = 333
    CUBLASLT_MATMUL_TILE_64x232 "CUBLASLT_MATMUL_TILE_64x232" = 334
    CUBLASLT_MATMUL_TILE_64x240 "CUBLASLT_MATMUL_TILE_64x240" = 335
    CUBLASLT_MATMUL_TILE_64x248 "CUBLASLT_MATMUL_TILE_64x248" = 336
    CUBLASLT_MATMUL_TILE_64x264 "CUBLASLT_MATMUL_TILE_64x264" = 337
    CUBLASLT_MATMUL_TILE_64x272 "CUBLASLT_MATMUL_TILE_64x272" = 338
    CUBLASLT_MATMUL_TILE_64x280 "CUBLASLT_MATMUL_TILE_64x280" = 339
    CUBLASLT_MATMUL_TILE_64x288 "CUBLASLT_MATMUL_TILE_64x288" = 340
    CUBLASLT_MATMUL_TILE_64x296 "CUBLASLT_MATMUL_TILE_64x296" = 341
    CUBLASLT_MATMUL_TILE_64x304 "CUBLASLT_MATMUL_TILE_64x304" = 342
    CUBLASLT_MATMUL_TILE_64x312 "CUBLASLT_MATMUL_TILE_64x312" = 343
    CUBLASLT_MATMUL_TILE_64x328 "CUBLASLT_MATMUL_TILE_64x328" = 344
    CUBLASLT_MATMUL_TILE_64x336 "CUBLASLT_MATMUL_TILE_64x336" = 345
    CUBLASLT_MATMUL_TILE_64x344 "CUBLASLT_MATMUL_TILE_64x344" = 346
    CUBLASLT_MATMUL_TILE_64x352 "CUBLASLT_MATMUL_TILE_64x352" = 347
    CUBLASLT_MATMUL_TILE_64x360 "CUBLASLT_MATMUL_TILE_64x360" = 348
    CUBLASLT_MATMUL_TILE_64x368 "CUBLASLT_MATMUL_TILE_64x368" = 349
    CUBLASLT_MATMUL_TILE_64x376 "CUBLASLT_MATMUL_TILE_64x376" = 350
    CUBLASLT_MATMUL_TILE_64x392 "CUBLASLT_MATMUL_TILE_64x392" = 351
    CUBLASLT_MATMUL_TILE_64x400 "CUBLASLT_MATMUL_TILE_64x400" = 352
    CUBLASLT_MATMUL_TILE_64x408 "CUBLASLT_MATMUL_TILE_64x408" = 353
    CUBLASLT_MATMUL_TILE_64x416 "CUBLASLT_MATMUL_TILE_64x416" = 354
    CUBLASLT_MATMUL_TILE_64x424 "CUBLASLT_MATMUL_TILE_64x424" = 355
    CUBLASLT_MATMUL_TILE_64x432 "CUBLASLT_MATMUL_TILE_64x432" = 356
    CUBLASLT_MATMUL_TILE_64x440 "CUBLASLT_MATMUL_TILE_64x440" = 357
    CUBLASLT_MATMUL_TILE_64x456 "CUBLASLT_MATMUL_TILE_64x456" = 358
    CUBLASLT_MATMUL_TILE_64x464 "CUBLASLT_MATMUL_TILE_64x464" = 359
    CUBLASLT_MATMUL_TILE_64x472 "CUBLASLT_MATMUL_TILE_64x472" = 360
    CUBLASLT_MATMUL_TILE_64x480 "CUBLASLT_MATMUL_TILE_64x480" = 361
    CUBLASLT_MATMUL_TILE_64x488 "CUBLASLT_MATMUL_TILE_64x488" = 362
    CUBLASLT_MATMUL_TILE_64x496 "CUBLASLT_MATMUL_TILE_64x496" = 363
    CUBLASLT_MATMUL_TILE_64x504 "CUBLASLT_MATMUL_TILE_64x504" = 364
    CUBLASLT_MATMUL_TILE_64x520 "CUBLASLT_MATMUL_TILE_64x520" = 365
    CUBLASLT_MATMUL_TILE_64x528 "CUBLASLT_MATMUL_TILE_64x528" = 366
    CUBLASLT_MATMUL_TILE_64x536 "CUBLASLT_MATMUL_TILE_64x536" = 367
    CUBLASLT_MATMUL_TILE_64x544 "CUBLASLT_MATMUL_TILE_64x544" = 368
    CUBLASLT_MATMUL_TILE_64x552 "CUBLASLT_MATMUL_TILE_64x552" = 369
    CUBLASLT_MATMUL_TILE_64x560 "CUBLASLT_MATMUL_TILE_64x560" = 370
    CUBLASLT_MATMUL_TILE_64x568 "CUBLASLT_MATMUL_TILE_64x568" = 371
    CUBLASLT_MATMUL_TILE_64x584 "CUBLASLT_MATMUL_TILE_64x584" = 372
    CUBLASLT_MATMUL_TILE_64x592 "CUBLASLT_MATMUL_TILE_64x592" = 373
    CUBLASLT_MATMUL_TILE_64x600 "CUBLASLT_MATMUL_TILE_64x600" = 374
    CUBLASLT_MATMUL_TILE_64x608 "CUBLASLT_MATMUL_TILE_64x608" = 375
    CUBLASLT_MATMUL_TILE_64x616 "CUBLASLT_MATMUL_TILE_64x616" = 376
    CUBLASLT_MATMUL_TILE_64x624 "CUBLASLT_MATMUL_TILE_64x624" = 377
    CUBLASLT_MATMUL_TILE_64x632 "CUBLASLT_MATMUL_TILE_64x632" = 378
    CUBLASLT_MATMUL_TILE_64x648 "CUBLASLT_MATMUL_TILE_64x648" = 379
    CUBLASLT_MATMUL_TILE_64x656 "CUBLASLT_MATMUL_TILE_64x656" = 380
    CUBLASLT_MATMUL_TILE_64x664 "CUBLASLT_MATMUL_TILE_64x664" = 381
    CUBLASLT_MATMUL_TILE_64x672 "CUBLASLT_MATMUL_TILE_64x672" = 382
    CUBLASLT_MATMUL_TILE_64x680 "CUBLASLT_MATMUL_TILE_64x680" = 383
    CUBLASLT_MATMUL_TILE_64x688 "CUBLASLT_MATMUL_TILE_64x688" = 384
    CUBLASLT_MATMUL_TILE_64x696 "CUBLASLT_MATMUL_TILE_64x696" = 385
    CUBLASLT_MATMUL_TILE_64x712 "CUBLASLT_MATMUL_TILE_64x712" = 386
    CUBLASLT_MATMUL_TILE_64x720 "CUBLASLT_MATMUL_TILE_64x720" = 387
    CUBLASLT_MATMUL_TILE_64x728 "CUBLASLT_MATMUL_TILE_64x728" = 388
    CUBLASLT_MATMUL_TILE_64x736 "CUBLASLT_MATMUL_TILE_64x736" = 389
    CUBLASLT_MATMUL_TILE_64x744 "CUBLASLT_MATMUL_TILE_64x744" = 390
    CUBLASLT_MATMUL_TILE_64x752 "CUBLASLT_MATMUL_TILE_64x752" = 391
    CUBLASLT_MATMUL_TILE_64x760 "CUBLASLT_MATMUL_TILE_64x760" = 392
    CUBLASLT_MATMUL_TILE_128x8 "CUBLASLT_MATMUL_TILE_128x8" = 393
    CUBLASLT_MATMUL_TILE_128x16 "CUBLASLT_MATMUL_TILE_128x16" = 394
    CUBLASLT_MATMUL_TILE_128x24 "CUBLASLT_MATMUL_TILE_128x24" = 395
    CUBLASLT_MATMUL_TILE_128x40 "CUBLASLT_MATMUL_TILE_128x40" = 396
    CUBLASLT_MATMUL_TILE_128x48 "CUBLASLT_MATMUL_TILE_128x48" = 397
    CUBLASLT_MATMUL_TILE_128x56 "CUBLASLT_MATMUL_TILE_128x56" = 398
    CUBLASLT_MATMUL_TILE_128x72 "CUBLASLT_MATMUL_TILE_128x72" = 399
    CUBLASLT_MATMUL_TILE_128x80 "CUBLASLT_MATMUL_TILE_128x80" = 400
    CUBLASLT_MATMUL_TILE_128x88 "CUBLASLT_MATMUL_TILE_128x88" = 401
    CUBLASLT_MATMUL_TILE_128x104 "CUBLASLT_MATMUL_TILE_128x104" = 402
    CUBLASLT_MATMUL_TILE_128x112 "CUBLASLT_MATMUL_TILE_128x112" = 403
    CUBLASLT_MATMUL_TILE_128x120 "CUBLASLT_MATMUL_TILE_128x120" = 404
    CUBLASLT_MATMUL_TILE_128x136 "CUBLASLT_MATMUL_TILE_128x136" = 405
    CUBLASLT_MATMUL_TILE_128x144 "CUBLASLT_MATMUL_TILE_128x144" = 406
    CUBLASLT_MATMUL_TILE_128x152 "CUBLASLT_MATMUL_TILE_128x152" = 407
    CUBLASLT_MATMUL_TILE_128x168 "CUBLASLT_MATMUL_TILE_128x168" = 408
    CUBLASLT_MATMUL_TILE_128x176 "CUBLASLT_MATMUL_TILE_128x176" = 409
    CUBLASLT_MATMUL_TILE_128x184 "CUBLASLT_MATMUL_TILE_128x184" = 410
    CUBLASLT_MATMUL_TILE_128x200 "CUBLASLT_MATMUL_TILE_128x200" = 411
    CUBLASLT_MATMUL_TILE_128x208 "CUBLASLT_MATMUL_TILE_128x208" = 412
    CUBLASLT_MATMUL_TILE_128x216 "CUBLASLT_MATMUL_TILE_128x216" = 413
    CUBLASLT_MATMUL_TILE_128x224 "CUBLASLT_MATMUL_TILE_128x224" = 414
    CUBLASLT_MATMUL_TILE_128x232 "CUBLASLT_MATMUL_TILE_128x232" = 415
    CUBLASLT_MATMUL_TILE_128x240 "CUBLASLT_MATMUL_TILE_128x240" = 416
    CUBLASLT_MATMUL_TILE_128x248 "CUBLASLT_MATMUL_TILE_128x248" = 417
    CUBLASLT_MATMUL_TILE_128x264 "CUBLASLT_MATMUL_TILE_128x264" = 418
    CUBLASLT_MATMUL_TILE_128x272 "CUBLASLT_MATMUL_TILE_128x272" = 419
    CUBLASLT_MATMUL_TILE_128x280 "CUBLASLT_MATMUL_TILE_128x280" = 420
    CUBLASLT_MATMUL_TILE_128x288 "CUBLASLT_MATMUL_TILE_128x288" = 421
    CUBLASLT_MATMUL_TILE_128x296 "CUBLASLT_MATMUL_TILE_128x296" = 422
    CUBLASLT_MATMUL_TILE_128x304 "CUBLASLT_MATMUL_TILE_128x304" = 423
    CUBLASLT_MATMUL_TILE_128x312 "CUBLASLT_MATMUL_TILE_128x312" = 424
    CUBLASLT_MATMUL_TILE_128x328 "CUBLASLT_MATMUL_TILE_128x328" = 425
    CUBLASLT_MATMUL_TILE_128x336 "CUBLASLT_MATMUL_TILE_128x336" = 426
    CUBLASLT_MATMUL_TILE_128x344 "CUBLASLT_MATMUL_TILE_128x344" = 427
    CUBLASLT_MATMUL_TILE_128x352 "CUBLASLT_MATMUL_TILE_128x352" = 428
    CUBLASLT_MATMUL_TILE_128x360 "CUBLASLT_MATMUL_TILE_128x360" = 429
    CUBLASLT_MATMUL_TILE_128x368 "CUBLASLT_MATMUL_TILE_128x368" = 430
    CUBLASLT_MATMUL_TILE_128x376 "CUBLASLT_MATMUL_TILE_128x376" = 431
    CUBLASLT_MATMUL_TILE_128x392 "CUBLASLT_MATMUL_TILE_128x392" = 432
    CUBLASLT_MATMUL_TILE_128x400 "CUBLASLT_MATMUL_TILE_128x400" = 433
    CUBLASLT_MATMUL_TILE_128x408 "CUBLASLT_MATMUL_TILE_128x408" = 434
    CUBLASLT_MATMUL_TILE_128x416 "CUBLASLT_MATMUL_TILE_128x416" = 435
    CUBLASLT_MATMUL_TILE_128x424 "CUBLASLT_MATMUL_TILE_128x424" = 436
    CUBLASLT_MATMUL_TILE_128x432 "CUBLASLT_MATMUL_TILE_128x432" = 437
    CUBLASLT_MATMUL_TILE_128x440 "CUBLASLT_MATMUL_TILE_128x440" = 438
    CUBLASLT_MATMUL_TILE_128x448 "CUBLASLT_MATMUL_TILE_128x448" = 439
    CUBLASLT_MATMUL_TILE_128x456 "CUBLASLT_MATMUL_TILE_128x456" = 440
    CUBLASLT_MATMUL_TILE_128x464 "CUBLASLT_MATMUL_TILE_128x464" = 441
    CUBLASLT_MATMUL_TILE_128x472 "CUBLASLT_MATMUL_TILE_128x472" = 442
    CUBLASLT_MATMUL_TILE_128x480 "CUBLASLT_MATMUL_TILE_128x480" = 443
    CUBLASLT_MATMUL_TILE_128x488 "CUBLASLT_MATMUL_TILE_128x488" = 444
    CUBLASLT_MATMUL_TILE_128x496 "CUBLASLT_MATMUL_TILE_128x496" = 445
    CUBLASLT_MATMUL_TILE_128x504 "CUBLASLT_MATMUL_TILE_128x504" = 446
    CUBLASLT_MATMUL_TILE_128x512 "CUBLASLT_MATMUL_TILE_128x512" = 447
    CUBLASLT_MATMUL_TILE_192x8 "CUBLASLT_MATMUL_TILE_192x8" = 448
    CUBLASLT_MATMUL_TILE_192x16 "CUBLASLT_MATMUL_TILE_192x16" = 449
    CUBLASLT_MATMUL_TILE_192x24 "CUBLASLT_MATMUL_TILE_192x24" = 450
    CUBLASLT_MATMUL_TILE_192x32 "CUBLASLT_MATMUL_TILE_192x32" = 451
    CUBLASLT_MATMUL_TILE_192x40 "CUBLASLT_MATMUL_TILE_192x40" = 452
    CUBLASLT_MATMUL_TILE_192x48 "CUBLASLT_MATMUL_TILE_192x48" = 453
    CUBLASLT_MATMUL_TILE_192x56 "CUBLASLT_MATMUL_TILE_192x56" = 454
    CUBLASLT_MATMUL_TILE_192x72 "CUBLASLT_MATMUL_TILE_192x72" = 455
    CUBLASLT_MATMUL_TILE_192x80 "CUBLASLT_MATMUL_TILE_192x80" = 456
    CUBLASLT_MATMUL_TILE_192x88 "CUBLASLT_MATMUL_TILE_192x88" = 457
    CUBLASLT_MATMUL_TILE_192x96 "CUBLASLT_MATMUL_TILE_192x96" = 458
    CUBLASLT_MATMUL_TILE_192x104 "CUBLASLT_MATMUL_TILE_192x104" = 459
    CUBLASLT_MATMUL_TILE_192x112 "CUBLASLT_MATMUL_TILE_192x112" = 460
    CUBLASLT_MATMUL_TILE_192x120 "CUBLASLT_MATMUL_TILE_192x120" = 461
    CUBLASLT_MATMUL_TILE_192x136 "CUBLASLT_MATMUL_TILE_192x136" = 462
    CUBLASLT_MATMUL_TILE_192x144 "CUBLASLT_MATMUL_TILE_192x144" = 463
    CUBLASLT_MATMUL_TILE_192x152 "CUBLASLT_MATMUL_TILE_192x152" = 464
    CUBLASLT_MATMUL_TILE_192x160 "CUBLASLT_MATMUL_TILE_192x160" = 465
    CUBLASLT_MATMUL_TILE_192x168 "CUBLASLT_MATMUL_TILE_192x168" = 466
    CUBLASLT_MATMUL_TILE_192x176 "CUBLASLT_MATMUL_TILE_192x176" = 467
    CUBLASLT_MATMUL_TILE_192x184 "CUBLASLT_MATMUL_TILE_192x184" = 468
    CUBLASLT_MATMUL_TILE_192x200 "CUBLASLT_MATMUL_TILE_192x200" = 469
    CUBLASLT_MATMUL_TILE_192x208 "CUBLASLT_MATMUL_TILE_192x208" = 470
    CUBLASLT_MATMUL_TILE_192x216 "CUBLASLT_MATMUL_TILE_192x216" = 471
    CUBLASLT_MATMUL_TILE_192x224 "CUBLASLT_MATMUL_TILE_192x224" = 472
    CUBLASLT_MATMUL_TILE_192x232 "CUBLASLT_MATMUL_TILE_192x232" = 473
    CUBLASLT_MATMUL_TILE_192x240 "CUBLASLT_MATMUL_TILE_192x240" = 474
    CUBLASLT_MATMUL_TILE_192x248 "CUBLASLT_MATMUL_TILE_192x248" = 475
    CUBLASLT_MATMUL_TILE_192x264 "CUBLASLT_MATMUL_TILE_192x264" = 476
    CUBLASLT_MATMUL_TILE_192x272 "CUBLASLT_MATMUL_TILE_192x272" = 477
    CUBLASLT_MATMUL_TILE_192x280 "CUBLASLT_MATMUL_TILE_192x280" = 478
    CUBLASLT_MATMUL_TILE_192x288 "CUBLASLT_MATMUL_TILE_192x288" = 479
    CUBLASLT_MATMUL_TILE_192x296 "CUBLASLT_MATMUL_TILE_192x296" = 480
    CUBLASLT_MATMUL_TILE_192x304 "CUBLASLT_MATMUL_TILE_192x304" = 481
    CUBLASLT_MATMUL_TILE_192x312 "CUBLASLT_MATMUL_TILE_192x312" = 482
    CUBLASLT_MATMUL_TILE_192x320 "CUBLASLT_MATMUL_TILE_192x320" = 483
    CUBLASLT_MATMUL_TILE_192x328 "CUBLASLT_MATMUL_TILE_192x328" = 484
    CUBLASLT_MATMUL_TILE_192x336 "CUBLASLT_MATMUL_TILE_192x336" = 485
    CUBLASLT_MATMUL_TILE_256x8 "CUBLASLT_MATMUL_TILE_256x8" = 486
    CUBLASLT_MATMUL_TILE_256x16 "CUBLASLT_MATMUL_TILE_256x16" = 487
    CUBLASLT_MATMUL_TILE_256x24 "CUBLASLT_MATMUL_TILE_256x24" = 488
    CUBLASLT_MATMUL_TILE_256x40 "CUBLASLT_MATMUL_TILE_256x40" = 489
    CUBLASLT_MATMUL_TILE_256x48 "CUBLASLT_MATMUL_TILE_256x48" = 490
    CUBLASLT_MATMUL_TILE_256x56 "CUBLASLT_MATMUL_TILE_256x56" = 491
    CUBLASLT_MATMUL_TILE_256x72 "CUBLASLT_MATMUL_TILE_256x72" = 492
    CUBLASLT_MATMUL_TILE_256x80 "CUBLASLT_MATMUL_TILE_256x80" = 493
    CUBLASLT_MATMUL_TILE_256x88 "CUBLASLT_MATMUL_TILE_256x88" = 494
    CUBLASLT_MATMUL_TILE_256x96 "CUBLASLT_MATMUL_TILE_256x96" = 495
    CUBLASLT_MATMUL_TILE_256x104 "CUBLASLT_MATMUL_TILE_256x104" = 496
    CUBLASLT_MATMUL_TILE_256x112 "CUBLASLT_MATMUL_TILE_256x112" = 497
    CUBLASLT_MATMUL_TILE_256x120 "CUBLASLT_MATMUL_TILE_256x120" = 498
    CUBLASLT_MATMUL_TILE_256x136 "CUBLASLT_MATMUL_TILE_256x136" = 499
    CUBLASLT_MATMUL_TILE_256x144 "CUBLASLT_MATMUL_TILE_256x144" = 500
    CUBLASLT_MATMUL_TILE_256x152 "CUBLASLT_MATMUL_TILE_256x152" = 501
    CUBLASLT_MATMUL_TILE_256x160 "CUBLASLT_MATMUL_TILE_256x160" = 502
    CUBLASLT_MATMUL_TILE_256x168 "CUBLASLT_MATMUL_TILE_256x168" = 503
    CUBLASLT_MATMUL_TILE_256x176 "CUBLASLT_MATMUL_TILE_256x176" = 504
    CUBLASLT_MATMUL_TILE_256x184 "CUBLASLT_MATMUL_TILE_256x184" = 505
    CUBLASLT_MATMUL_TILE_256x200 "CUBLASLT_MATMUL_TILE_256x200" = 506
    CUBLASLT_MATMUL_TILE_256x208 "CUBLASLT_MATMUL_TILE_256x208" = 507
    CUBLASLT_MATMUL_TILE_256x216 "CUBLASLT_MATMUL_TILE_256x216" = 508
    CUBLASLT_MATMUL_TILE_256x224 "CUBLASLT_MATMUL_TILE_256x224" = 509
    CUBLASLT_MATMUL_TILE_256x232 "CUBLASLT_MATMUL_TILE_256x232" = 510
    CUBLASLT_MATMUL_TILE_256x240 "CUBLASLT_MATMUL_TILE_256x240" = 511
    CUBLASLT_MATMUL_TILE_256x248 "CUBLASLT_MATMUL_TILE_256x248" = 512
    CUBLASLT_MATMUL_TILE_256x256 "CUBLASLT_MATMUL_TILE_256x256" = 513
    CUBLASLT_MATMUL_TILE_320x8 "CUBLASLT_MATMUL_TILE_320x8" = 514
    CUBLASLT_MATMUL_TILE_320x16 "CUBLASLT_MATMUL_TILE_320x16" = 515
    CUBLASLT_MATMUL_TILE_320x24 "CUBLASLT_MATMUL_TILE_320x24" = 516
    CUBLASLT_MATMUL_TILE_320x32 "CUBLASLT_MATMUL_TILE_320x32" = 517
    CUBLASLT_MATMUL_TILE_320x40 "CUBLASLT_MATMUL_TILE_320x40" = 518
    CUBLASLT_MATMUL_TILE_320x48 "CUBLASLT_MATMUL_TILE_320x48" = 519
    CUBLASLT_MATMUL_TILE_320x56 "CUBLASLT_MATMUL_TILE_320x56" = 520
    CUBLASLT_MATMUL_TILE_320x72 "CUBLASLT_MATMUL_TILE_320x72" = 521
    CUBLASLT_MATMUL_TILE_320x80 "CUBLASLT_MATMUL_TILE_320x80" = 522
    CUBLASLT_MATMUL_TILE_320x88 "CUBLASLT_MATMUL_TILE_320x88" = 523
    CUBLASLT_MATMUL_TILE_320x96 "CUBLASLT_MATMUL_TILE_320x96" = 524
    CUBLASLT_MATMUL_TILE_320x104 "CUBLASLT_MATMUL_TILE_320x104" = 525
    CUBLASLT_MATMUL_TILE_320x112 "CUBLASLT_MATMUL_TILE_320x112" = 526
    CUBLASLT_MATMUL_TILE_320x120 "CUBLASLT_MATMUL_TILE_320x120" = 527
    CUBLASLT_MATMUL_TILE_320x136 "CUBLASLT_MATMUL_TILE_320x136" = 528
    CUBLASLT_MATMUL_TILE_320x144 "CUBLASLT_MATMUL_TILE_320x144" = 529
    CUBLASLT_MATMUL_TILE_320x152 "CUBLASLT_MATMUL_TILE_320x152" = 530
    CUBLASLT_MATMUL_TILE_320x160 "CUBLASLT_MATMUL_TILE_320x160" = 531
    CUBLASLT_MATMUL_TILE_320x168 "CUBLASLT_MATMUL_TILE_320x168" = 532
    CUBLASLT_MATMUL_TILE_320x176 "CUBLASLT_MATMUL_TILE_320x176" = 533
    CUBLASLT_MATMUL_TILE_320x184 "CUBLASLT_MATMUL_TILE_320x184" = 534
    CUBLASLT_MATMUL_TILE_320x192 "CUBLASLT_MATMUL_TILE_320x192" = 535
    CUBLASLT_MATMUL_TILE_320x200 "CUBLASLT_MATMUL_TILE_320x200" = 536
    CUBLASLT_MATMUL_TILE_384x8 "CUBLASLT_MATMUL_TILE_384x8" = 537
    CUBLASLT_MATMUL_TILE_384x16 "CUBLASLT_MATMUL_TILE_384x16" = 538
    CUBLASLT_MATMUL_TILE_384x24 "CUBLASLT_MATMUL_TILE_384x24" = 539
    CUBLASLT_MATMUL_TILE_384x32 "CUBLASLT_MATMUL_TILE_384x32" = 540
    CUBLASLT_MATMUL_TILE_384x40 "CUBLASLT_MATMUL_TILE_384x40" = 541
    CUBLASLT_MATMUL_TILE_384x48 "CUBLASLT_MATMUL_TILE_384x48" = 542
    CUBLASLT_MATMUL_TILE_384x56 "CUBLASLT_MATMUL_TILE_384x56" = 543
    CUBLASLT_MATMUL_TILE_384x72 "CUBLASLT_MATMUL_TILE_384x72" = 544
    CUBLASLT_MATMUL_TILE_384x80 "CUBLASLT_MATMUL_TILE_384x80" = 545
    CUBLASLT_MATMUL_TILE_384x88 "CUBLASLT_MATMUL_TILE_384x88" = 546
    CUBLASLT_MATMUL_TILE_384x96 "CUBLASLT_MATMUL_TILE_384x96" = 547
    CUBLASLT_MATMUL_TILE_384x104 "CUBLASLT_MATMUL_TILE_384x104" = 548
    CUBLASLT_MATMUL_TILE_384x112 "CUBLASLT_MATMUL_TILE_384x112" = 549
    CUBLASLT_MATMUL_TILE_384x120 "CUBLASLT_MATMUL_TILE_384x120" = 550
    CUBLASLT_MATMUL_TILE_384x136 "CUBLASLT_MATMUL_TILE_384x136" = 551
    CUBLASLT_MATMUL_TILE_384x144 "CUBLASLT_MATMUL_TILE_384x144" = 552
    CUBLASLT_MATMUL_TILE_384x152 "CUBLASLT_MATMUL_TILE_384x152" = 553
    CUBLASLT_MATMUL_TILE_384x160 "CUBLASLT_MATMUL_TILE_384x160" = 554
    CUBLASLT_MATMUL_TILE_384x168 "CUBLASLT_MATMUL_TILE_384x168" = 555
    CUBLASLT_MATMUL_TILE_448x8 "CUBLASLT_MATMUL_TILE_448x8" = 556
    CUBLASLT_MATMUL_TILE_448x16 "CUBLASLT_MATMUL_TILE_448x16" = 557
    CUBLASLT_MATMUL_TILE_448x24 "CUBLASLT_MATMUL_TILE_448x24" = 558
    CUBLASLT_MATMUL_TILE_448x32 "CUBLASLT_MATMUL_TILE_448x32" = 559
    CUBLASLT_MATMUL_TILE_448x40 "CUBLASLT_MATMUL_TILE_448x40" = 560
    CUBLASLT_MATMUL_TILE_448x48 "CUBLASLT_MATMUL_TILE_448x48" = 561
    CUBLASLT_MATMUL_TILE_448x56 "CUBLASLT_MATMUL_TILE_448x56" = 562
    CUBLASLT_MATMUL_TILE_448x72 "CUBLASLT_MATMUL_TILE_448x72" = 563
    CUBLASLT_MATMUL_TILE_448x80 "CUBLASLT_MATMUL_TILE_448x80" = 564
    CUBLASLT_MATMUL_TILE_448x88 "CUBLASLT_MATMUL_TILE_448x88" = 565
    CUBLASLT_MATMUL_TILE_448x96 "CUBLASLT_MATMUL_TILE_448x96" = 566
    CUBLASLT_MATMUL_TILE_448x104 "CUBLASLT_MATMUL_TILE_448x104" = 567
    CUBLASLT_MATMUL_TILE_448x112 "CUBLASLT_MATMUL_TILE_448x112" = 568
    CUBLASLT_MATMUL_TILE_448x120 "CUBLASLT_MATMUL_TILE_448x120" = 569
    CUBLASLT_MATMUL_TILE_448x128 "CUBLASLT_MATMUL_TILE_448x128" = 570
    CUBLASLT_MATMUL_TILE_448x136 "CUBLASLT_MATMUL_TILE_448x136" = 571
    CUBLASLT_MATMUL_TILE_448x144 "CUBLASLT_MATMUL_TILE_448x144" = 572
    CUBLASLT_MATMUL_TILE_512x8 "CUBLASLT_MATMUL_TILE_512x8" = 573
    CUBLASLT_MATMUL_TILE_512x16 "CUBLASLT_MATMUL_TILE_512x16" = 574
    CUBLASLT_MATMUL_TILE_512x24 "CUBLASLT_MATMUL_TILE_512x24" = 575
    CUBLASLT_MATMUL_TILE_512x32 "CUBLASLT_MATMUL_TILE_512x32" = 576
    CUBLASLT_MATMUL_TILE_512x40 "CUBLASLT_MATMUL_TILE_512x40" = 577
    CUBLASLT_MATMUL_TILE_512x48 "CUBLASLT_MATMUL_TILE_512x48" = 578
    CUBLASLT_MATMUL_TILE_512x56 "CUBLASLT_MATMUL_TILE_512x56" = 579
    CUBLASLT_MATMUL_TILE_512x72 "CUBLASLT_MATMUL_TILE_512x72" = 580
    CUBLASLT_MATMUL_TILE_512x80 "CUBLASLT_MATMUL_TILE_512x80" = 581
    CUBLASLT_MATMUL_TILE_512x88 "CUBLASLT_MATMUL_TILE_512x88" = 582
    CUBLASLT_MATMUL_TILE_512x96 "CUBLASLT_MATMUL_TILE_512x96" = 583
    CUBLASLT_MATMUL_TILE_512x104 "CUBLASLT_MATMUL_TILE_512x104" = 584
    CUBLASLT_MATMUL_TILE_512x112 "CUBLASLT_MATMUL_TILE_512x112" = 585
    CUBLASLT_MATMUL_TILE_512x120 "CUBLASLT_MATMUL_TILE_512x120" = 586
    CUBLASLT_MATMUL_TILE_512x128 "CUBLASLT_MATMUL_TILE_512x128" = 587
    CUBLASLT_MATMUL_TILE_576x8 "CUBLASLT_MATMUL_TILE_576x8" = 588
    CUBLASLT_MATMUL_TILE_576x16 "CUBLASLT_MATMUL_TILE_576x16" = 589
    CUBLASLT_MATMUL_TILE_576x24 "CUBLASLT_MATMUL_TILE_576x24" = 590
    CUBLASLT_MATMUL_TILE_576x32 "CUBLASLT_MATMUL_TILE_576x32" = 591
    CUBLASLT_MATMUL_TILE_576x40 "CUBLASLT_MATMUL_TILE_576x40" = 592
    CUBLASLT_MATMUL_TILE_576x48 "CUBLASLT_MATMUL_TILE_576x48" = 593
    CUBLASLT_MATMUL_TILE_576x56 "CUBLASLT_MATMUL_TILE_576x56" = 594
    CUBLASLT_MATMUL_TILE_576x72 "CUBLASLT_MATMUL_TILE_576x72" = 595
    CUBLASLT_MATMUL_TILE_576x80 "CUBLASLT_MATMUL_TILE_576x80" = 596
    CUBLASLT_MATMUL_TILE_576x88 "CUBLASLT_MATMUL_TILE_576x88" = 597
    CUBLASLT_MATMUL_TILE_576x96 "CUBLASLT_MATMUL_TILE_576x96" = 598
    CUBLASLT_MATMUL_TILE_576x104 "CUBLASLT_MATMUL_TILE_576x104" = 599
    CUBLASLT_MATMUL_TILE_576x112 "CUBLASLT_MATMUL_TILE_576x112" = 600
    CUBLASLT_MATMUL_TILE_640x8 "CUBLASLT_MATMUL_TILE_640x8" = 601
    CUBLASLT_MATMUL_TILE_640x16 "CUBLASLT_MATMUL_TILE_640x16" = 602
    CUBLASLT_MATMUL_TILE_640x24 "CUBLASLT_MATMUL_TILE_640x24" = 603
    CUBLASLT_MATMUL_TILE_640x32 "CUBLASLT_MATMUL_TILE_640x32" = 604
    CUBLASLT_MATMUL_TILE_640x40 "CUBLASLT_MATMUL_TILE_640x40" = 605
    CUBLASLT_MATMUL_TILE_640x48 "CUBLASLT_MATMUL_TILE_640x48" = 606
    CUBLASLT_MATMUL_TILE_640x56 "CUBLASLT_MATMUL_TILE_640x56" = 607
    CUBLASLT_MATMUL_TILE_640x72 "CUBLASLT_MATMUL_TILE_640x72" = 608
    CUBLASLT_MATMUL_TILE_640x80 "CUBLASLT_MATMUL_TILE_640x80" = 609
    CUBLASLT_MATMUL_TILE_640x88 "CUBLASLT_MATMUL_TILE_640x88" = 610
    CUBLASLT_MATMUL_TILE_640x96 "CUBLASLT_MATMUL_TILE_640x96" = 611
    CUBLASLT_MATMUL_TILE_704x8 "CUBLASLT_MATMUL_TILE_704x8" = 612
    CUBLASLT_MATMUL_TILE_704x16 "CUBLASLT_MATMUL_TILE_704x16" = 613
    CUBLASLT_MATMUL_TILE_704x24 "CUBLASLT_MATMUL_TILE_704x24" = 614
    CUBLASLT_MATMUL_TILE_704x32 "CUBLASLT_MATMUL_TILE_704x32" = 615
    CUBLASLT_MATMUL_TILE_704x40 "CUBLASLT_MATMUL_TILE_704x40" = 616
    CUBLASLT_MATMUL_TILE_704x48 "CUBLASLT_MATMUL_TILE_704x48" = 617
    CUBLASLT_MATMUL_TILE_704x56 "CUBLASLT_MATMUL_TILE_704x56" = 618
    CUBLASLT_MATMUL_TILE_704x72 "CUBLASLT_MATMUL_TILE_704x72" = 619
    CUBLASLT_MATMUL_TILE_704x80 "CUBLASLT_MATMUL_TILE_704x80" = 620
    CUBLASLT_MATMUL_TILE_704x88 "CUBLASLT_MATMUL_TILE_704x88" = 621
    CUBLASLT_MATMUL_TILE_768x8 "CUBLASLT_MATMUL_TILE_768x8" = 622
    CUBLASLT_MATMUL_TILE_768x16 "CUBLASLT_MATMUL_TILE_768x16" = 623
    CUBLASLT_MATMUL_TILE_768x24 "CUBLASLT_MATMUL_TILE_768x24" = 624
    CUBLASLT_MATMUL_TILE_768x32 "CUBLASLT_MATMUL_TILE_768x32" = 625
    CUBLASLT_MATMUL_TILE_768x40 "CUBLASLT_MATMUL_TILE_768x40" = 626
    CUBLASLT_MATMUL_TILE_768x48 "CUBLASLT_MATMUL_TILE_768x48" = 627
    CUBLASLT_MATMUL_TILE_768x56 "CUBLASLT_MATMUL_TILE_768x56" = 628
    CUBLASLT_MATMUL_TILE_768x72 "CUBLASLT_MATMUL_TILE_768x72" = 629
    CUBLASLT_MATMUL_TILE_768x80 "CUBLASLT_MATMUL_TILE_768x80" = 630
    CUBLASLT_MATMUL_TILE_256x512 "CUBLASLT_MATMUL_TILE_256x512" = 631
    CUBLASLT_MATMUL_TILE_256x1024 "CUBLASLT_MATMUL_TILE_256x1024" = 632
    CUBLASLT_MATMUL_TILE_512x512 "CUBLASLT_MATMUL_TILE_512x512" = 633
    CUBLASLT_MATMUL_TILE_512x1024 "CUBLASLT_MATMUL_TILE_512x1024" = 634

ctypedef enum cublasLtMatmulStages_t "cublasLtMatmulStages_t":
    CUBLASLT_MATMUL_STAGES_UNDEFINED "CUBLASLT_MATMUL_STAGES_UNDEFINED" = 0
    CUBLASLT_MATMUL_STAGES_16x1 "CUBLASLT_MATMUL_STAGES_16x1" = 1
    CUBLASLT_MATMUL_STAGES_16x2 "CUBLASLT_MATMUL_STAGES_16x2" = 2
    CUBLASLT_MATMUL_STAGES_16x3 "CUBLASLT_MATMUL_STAGES_16x3" = 3
    CUBLASLT_MATMUL_STAGES_16x4 "CUBLASLT_MATMUL_STAGES_16x4" = 4
    CUBLASLT_MATMUL_STAGES_16x5 "CUBLASLT_MATMUL_STAGES_16x5" = 5
    CUBLASLT_MATMUL_STAGES_16x6 "CUBLASLT_MATMUL_STAGES_16x6" = 6
    CUBLASLT_MATMUL_STAGES_32x1 "CUBLASLT_MATMUL_STAGES_32x1" = 7
    CUBLASLT_MATMUL_STAGES_32x2 "CUBLASLT_MATMUL_STAGES_32x2" = 8
    CUBLASLT_MATMUL_STAGES_32x3 "CUBLASLT_MATMUL_STAGES_32x3" = 9
    CUBLASLT_MATMUL_STAGES_32x4 "CUBLASLT_MATMUL_STAGES_32x4" = 10
    CUBLASLT_MATMUL_STAGES_32x5 "CUBLASLT_MATMUL_STAGES_32x5" = 11
    CUBLASLT_MATMUL_STAGES_32x6 "CUBLASLT_MATMUL_STAGES_32x6" = 12
    CUBLASLT_MATMUL_STAGES_64x1 "CUBLASLT_MATMUL_STAGES_64x1" = 13
    CUBLASLT_MATMUL_STAGES_64x2 "CUBLASLT_MATMUL_STAGES_64x2" = 14
    CUBLASLT_MATMUL_STAGES_64x3 "CUBLASLT_MATMUL_STAGES_64x3" = 15
    CUBLASLT_MATMUL_STAGES_64x4 "CUBLASLT_MATMUL_STAGES_64x4" = 16
    CUBLASLT_MATMUL_STAGES_64x5 "CUBLASLT_MATMUL_STAGES_64x5" = 17
    CUBLASLT_MATMUL_STAGES_64x6 "CUBLASLT_MATMUL_STAGES_64x6" = 18
    CUBLASLT_MATMUL_STAGES_128x1 "CUBLASLT_MATMUL_STAGES_128x1" = 19
    CUBLASLT_MATMUL_STAGES_128x2 "CUBLASLT_MATMUL_STAGES_128x2" = 20
    CUBLASLT_MATMUL_STAGES_128x3 "CUBLASLT_MATMUL_STAGES_128x3" = 21
    CUBLASLT_MATMUL_STAGES_128x4 "CUBLASLT_MATMUL_STAGES_128x4" = 22
    CUBLASLT_MATMUL_STAGES_128x5 "CUBLASLT_MATMUL_STAGES_128x5" = 23
    CUBLASLT_MATMUL_STAGES_128x6 "CUBLASLT_MATMUL_STAGES_128x6" = 24
    CUBLASLT_MATMUL_STAGES_32x10 "CUBLASLT_MATMUL_STAGES_32x10" = 25
    CUBLASLT_MATMUL_STAGES_8x4 "CUBLASLT_MATMUL_STAGES_8x4" = 26
    CUBLASLT_MATMUL_STAGES_16x10 "CUBLASLT_MATMUL_STAGES_16x10" = 27
    CUBLASLT_MATMUL_STAGES_8x5 "CUBLASLT_MATMUL_STAGES_8x5" = 28
    CUBLASLT_MATMUL_STAGES_8x3 "CUBLASLT_MATMUL_STAGES_8x3" = 31
    CUBLASLT_MATMUL_STAGES_8xAUTO "CUBLASLT_MATMUL_STAGES_8xAUTO" = 32
    CUBLASLT_MATMUL_STAGES_16xAUTO "CUBLASLT_MATMUL_STAGES_16xAUTO" = 33
    CUBLASLT_MATMUL_STAGES_32xAUTO "CUBLASLT_MATMUL_STAGES_32xAUTO" = 34
    CUBLASLT_MATMUL_STAGES_64xAUTO "CUBLASLT_MATMUL_STAGES_64xAUTO" = 35
    CUBLASLT_MATMUL_STAGES_128xAUTO "CUBLASLT_MATMUL_STAGES_128xAUTO" = 36
    CUBLASLT_MATMUL_STAGES_256xAUTO "CUBLASLT_MATMUL_STAGES_256xAUTO" = 37
    CUBLASLT_MATMUL_STAGES_16x80 "CUBLASLT_MATMUL_STAGES_16x80" = 29
    CUBLASLT_MATMUL_STAGES_64x80 "CUBLASLT_MATMUL_STAGES_64x80" = 30

ctypedef enum cublasLtPointerMode_t "cublasLtPointerMode_t":
    CUBLASLT_POINTER_MODE_HOST "CUBLASLT_POINTER_MODE_HOST" = CUBLAS_POINTER_MODE_HOST
    CUBLASLT_POINTER_MODE_DEVICE "CUBLASLT_POINTER_MODE_DEVICE" = CUBLAS_POINTER_MODE_DEVICE
    CUBLASLT_POINTER_MODE_DEVICE_VECTOR "CUBLASLT_POINTER_MODE_DEVICE_VECTOR" = 2
    CUBLASLT_POINTER_MODE_ALPHA_DEVICE_VECTOR_BETA_ZERO "CUBLASLT_POINTER_MODE_ALPHA_DEVICE_VECTOR_BETA_ZERO" = 3
    CUBLASLT_POINTER_MODE_ALPHA_DEVICE_VECTOR_BETA_HOST "CUBLASLT_POINTER_MODE_ALPHA_DEVICE_VECTOR_BETA_HOST" = 4

ctypedef enum cublasLtPointerModeMask_t "cublasLtPointerModeMask_t":
    CUBLASLT_POINTER_MODE_MASK_HOST "CUBLASLT_POINTER_MODE_MASK_HOST" = 1
    CUBLASLT_POINTER_MODE_MASK_DEVICE "CUBLASLT_POINTER_MODE_MASK_DEVICE" = 2
    CUBLASLT_POINTER_MODE_MASK_DEVICE_VECTOR "CUBLASLT_POINTER_MODE_MASK_DEVICE_VECTOR" = 4
    CUBLASLT_POINTER_MODE_MASK_ALPHA_DEVICE_VECTOR_BETA_ZERO "CUBLASLT_POINTER_MODE_MASK_ALPHA_DEVICE_VECTOR_BETA_ZERO" = 8
    CUBLASLT_POINTER_MODE_MASK_ALPHA_DEVICE_VECTOR_BETA_HOST "CUBLASLT_POINTER_MODE_MASK_ALPHA_DEVICE_VECTOR_BETA_HOST" = 16
    CUBLASLT_POINTER_MODE_MASK_NO_FILTERING "CUBLASLT_POINTER_MODE_MASK_NO_FILTERING" = 0

ctypedef enum cublasLtOrder_t "cublasLtOrder_t":
    CUBLASLT_ORDER_COL "CUBLASLT_ORDER_COL" = 0
    CUBLASLT_ORDER_ROW "CUBLASLT_ORDER_ROW" = 1
    CUBLASLT_ORDER_COL32 "CUBLASLT_ORDER_COL32" = 2
    CUBLASLT_ORDER_COL4_4R2_8C "CUBLASLT_ORDER_COL4_4R2_8C" = 3
    CUBLASLT_ORDER_COL32_2R_4R4 "CUBLASLT_ORDER_COL32_2R_4R4" = 4

ctypedef enum cublasLtMatrixLayoutAttribute_t "cublasLtMatrixLayoutAttribute_t":
    CUBLASLT_MATRIX_LAYOUT_TYPE "CUBLASLT_MATRIX_LAYOUT_TYPE" = 0
    CUBLASLT_MATRIX_LAYOUT_ORDER "CUBLASLT_MATRIX_LAYOUT_ORDER" = 1
    CUBLASLT_MATRIX_LAYOUT_ROWS "CUBLASLT_MATRIX_LAYOUT_ROWS" = 2
    CUBLASLT_MATRIX_LAYOUT_COLS "CUBLASLT_MATRIX_LAYOUT_COLS" = 3
    CUBLASLT_MATRIX_LAYOUT_LD "CUBLASLT_MATRIX_LAYOUT_LD" = 4
    CUBLASLT_MATRIX_LAYOUT_BATCH_COUNT "CUBLASLT_MATRIX_LAYOUT_BATCH_COUNT" = 5
    CUBLASLT_MATRIX_LAYOUT_STRIDED_BATCH_OFFSET "CUBLASLT_MATRIX_LAYOUT_STRIDED_BATCH_OFFSET" = 6
    CUBLASLT_MATRIX_LAYOUT_PLANE_OFFSET "CUBLASLT_MATRIX_LAYOUT_PLANE_OFFSET" = 7

ctypedef enum cublasLtMatmulDescAttributes_t "cublasLtMatmulDescAttributes_t":
    CUBLASLT_MATMUL_DESC_COMPUTE_TYPE "CUBLASLT_MATMUL_DESC_COMPUTE_TYPE" = 0
    CUBLASLT_MATMUL_DESC_SCALE_TYPE "CUBLASLT_MATMUL_DESC_SCALE_TYPE" = 1
    CUBLASLT_MATMUL_DESC_POINTER_MODE "CUBLASLT_MATMUL_DESC_POINTER_MODE" = 2
    CUBLASLT_MATMUL_DESC_TRANSA "CUBLASLT_MATMUL_DESC_TRANSA" = 3
    CUBLASLT_MATMUL_DESC_TRANSB "CUBLASLT_MATMUL_DESC_TRANSB" = 4
    CUBLASLT_MATMUL_DESC_TRANSC "CUBLASLT_MATMUL_DESC_TRANSC" = 5
    CUBLASLT_MATMUL_DESC_FILL_MODE "CUBLASLT_MATMUL_DESC_FILL_MODE" = 6
    CUBLASLT_MATMUL_DESC_EPILOGUE "CUBLASLT_MATMUL_DESC_EPILOGUE" = 7
    CUBLASLT_MATMUL_DESC_BIAS_POINTER "CUBLASLT_MATMUL_DESC_BIAS_POINTER" = 8
    CUBLASLT_MATMUL_DESC_BIAS_BATCH_STRIDE "CUBLASLT_MATMUL_DESC_BIAS_BATCH_STRIDE" = 10
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_POINTER "CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_POINTER" = 11
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_LD "CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_LD" = 12
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_BATCH_STRIDE "CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_BATCH_STRIDE" = 13
    CUBLASLT_MATMUL_DESC_ALPHA_VECTOR_BATCH_STRIDE "CUBLASLT_MATMUL_DESC_ALPHA_VECTOR_BATCH_STRIDE" = 14
    CUBLASLT_MATMUL_DESC_SM_COUNT_TARGET "CUBLASLT_MATMUL_DESC_SM_COUNT_TARGET" = 15
    CUBLASLT_MATMUL_DESC_A_SCALE_POINTER "CUBLASLT_MATMUL_DESC_A_SCALE_POINTER" = 17
    CUBLASLT_MATMUL_DESC_B_SCALE_POINTER "CUBLASLT_MATMUL_DESC_B_SCALE_POINTER" = 18
    CUBLASLT_MATMUL_DESC_C_SCALE_POINTER "CUBLASLT_MATMUL_DESC_C_SCALE_POINTER" = 19
    CUBLASLT_MATMUL_DESC_D_SCALE_POINTER "CUBLASLT_MATMUL_DESC_D_SCALE_POINTER" = 20
    CUBLASLT_MATMUL_DESC_AMAX_D_POINTER "CUBLASLT_MATMUL_DESC_AMAX_D_POINTER" = 21
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_DATA_TYPE "CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_DATA_TYPE" = 22
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_SCALE_POINTER "CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_SCALE_POINTER" = 23
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_AMAX_POINTER "CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_AMAX_POINTER" = 24
    CUBLASLT_MATMUL_DESC_FAST_ACCUM "CUBLASLT_MATMUL_DESC_FAST_ACCUM" = 25
    CUBLASLT_MATMUL_DESC_BIAS_DATA_TYPE "CUBLASLT_MATMUL_DESC_BIAS_DATA_TYPE" = 26
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_NUM_CHUNKS_D_ROWS "CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_NUM_CHUNKS_D_ROWS" = 27
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_NUM_CHUNKS_D_COLS "CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_NUM_CHUNKS_D_COLS" = 28
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_IN_COUNTERS_POINTER "CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_IN_COUNTERS_POINTER" = 29
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_OUT_COUNTERS_POINTER "CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_OUT_COUNTERS_POINTER" = 30
    CUBLASLT_MATMUL_DESC_A_SCALE_MODE "CUBLASLT_MATMUL_DESC_A_SCALE_MODE" = 31
    CUBLASLT_MATMUL_DESC_B_SCALE_MODE "CUBLASLT_MATMUL_DESC_B_SCALE_MODE" = 32
    CUBLASLT_MATMUL_DESC_C_SCALE_MODE "CUBLASLT_MATMUL_DESC_C_SCALE_MODE" = 33
    CUBLASLT_MATMUL_DESC_D_SCALE_MODE "CUBLASLT_MATMUL_DESC_D_SCALE_MODE" = 34
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_SCALE_MODE "CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_SCALE_MODE" = 35
    CUBLASLT_MATMUL_DESC_D_OUT_SCALE_POINTER "CUBLASLT_MATMUL_DESC_D_OUT_SCALE_POINTER" = 36
    CUBLASLT_MATMUL_DESC_D_OUT_SCALE_MODE "CUBLASLT_MATMUL_DESC_D_OUT_SCALE_MODE" = 37

ctypedef enum cublasLtMatrixTransformDescAttributes_t "cublasLtMatrixTransformDescAttributes_t":
    CUBLASLT_MATRIX_TRANSFORM_DESC_SCALE_TYPE "CUBLASLT_MATRIX_TRANSFORM_DESC_SCALE_TYPE"
    CUBLASLT_MATRIX_TRANSFORM_DESC_POINTER_MODE "CUBLASLT_MATRIX_TRANSFORM_DESC_POINTER_MODE"
    CUBLASLT_MATRIX_TRANSFORM_DESC_TRANSA "CUBLASLT_MATRIX_TRANSFORM_DESC_TRANSA"
    CUBLASLT_MATRIX_TRANSFORM_DESC_TRANSB "CUBLASLT_MATRIX_TRANSFORM_DESC_TRANSB"

ctypedef enum cublasLtReductionScheme_t "cublasLtReductionScheme_t":
    CUBLASLT_REDUCTION_SCHEME_NONE "CUBLASLT_REDUCTION_SCHEME_NONE" = 0
    CUBLASLT_REDUCTION_SCHEME_INPLACE "CUBLASLT_REDUCTION_SCHEME_INPLACE" = 1
    CUBLASLT_REDUCTION_SCHEME_COMPUTE_TYPE "CUBLASLT_REDUCTION_SCHEME_COMPUTE_TYPE" = 2
    CUBLASLT_REDUCTION_SCHEME_OUTPUT_TYPE "CUBLASLT_REDUCTION_SCHEME_OUTPUT_TYPE" = 4
    CUBLASLT_REDUCTION_SCHEME_MASK "CUBLASLT_REDUCTION_SCHEME_MASK" = 0x7

ctypedef enum cublasLtEpilogue_t "cublasLtEpilogue_t":
    CUBLASLT_EPILOGUE_DEFAULT "CUBLASLT_EPILOGUE_DEFAULT" = 1
    CUBLASLT_EPILOGUE_RELU "CUBLASLT_EPILOGUE_RELU" = 2
    CUBLASLT_EPILOGUE_RELU_AUX "CUBLASLT_EPILOGUE_RELU_AUX" = (CUBLASLT_EPILOGUE_RELU | 128)
    CUBLASLT_EPILOGUE_BIAS "CUBLASLT_EPILOGUE_BIAS" = 4
    CUBLASLT_EPILOGUE_RELU_BIAS "CUBLASLT_EPILOGUE_RELU_BIAS" = (CUBLASLT_EPILOGUE_RELU | CUBLASLT_EPILOGUE_BIAS)
    CUBLASLT_EPILOGUE_RELU_AUX_BIAS "CUBLASLT_EPILOGUE_RELU_AUX_BIAS" = (CUBLASLT_EPILOGUE_RELU_AUX | CUBLASLT_EPILOGUE_BIAS)
    CUBLASLT_EPILOGUE_DRELU "CUBLASLT_EPILOGUE_DRELU" = (8 | 128)
    CUBLASLT_EPILOGUE_DRELU_BGRAD "CUBLASLT_EPILOGUE_DRELU_BGRAD" = (CUBLASLT_EPILOGUE_DRELU | 16)
    CUBLASLT_EPILOGUE_GELU "CUBLASLT_EPILOGUE_GELU" = 32
    CUBLASLT_EPILOGUE_GELU_AUX "CUBLASLT_EPILOGUE_GELU_AUX" = (CUBLASLT_EPILOGUE_GELU | 128)
    CUBLASLT_EPILOGUE_GELU_BIAS "CUBLASLT_EPILOGUE_GELU_BIAS" = (CUBLASLT_EPILOGUE_GELU | CUBLASLT_EPILOGUE_BIAS)
    CUBLASLT_EPILOGUE_GELU_AUX_BIAS "CUBLASLT_EPILOGUE_GELU_AUX_BIAS" = (CUBLASLT_EPILOGUE_GELU_AUX | CUBLASLT_EPILOGUE_BIAS)
    CUBLASLT_EPILOGUE_DGELU "CUBLASLT_EPILOGUE_DGELU" = (64 | 128)
    CUBLASLT_EPILOGUE_DGELU_BGRAD "CUBLASLT_EPILOGUE_DGELU_BGRAD" = (CUBLASLT_EPILOGUE_DGELU | 16)
    CUBLASLT_EPILOGUE_BGRADA "CUBLASLT_EPILOGUE_BGRADA" = 256
    CUBLASLT_EPILOGUE_BGRADB "CUBLASLT_EPILOGUE_BGRADB" = 512

ctypedef enum cublasLtMatmulSearch_t "cublasLtMatmulSearch_t":
    CUBLASLT_SEARCH_BEST_FIT "CUBLASLT_SEARCH_BEST_FIT" = 0
    CUBLASLT_SEARCH_LIMITED_BY_ALGO_ID "CUBLASLT_SEARCH_LIMITED_BY_ALGO_ID" = 1
    CUBLASLT_SEARCH_RESERVED_02 "CUBLASLT_SEARCH_RESERVED_02" = 2
    CUBLASLT_SEARCH_RESERVED_03 "CUBLASLT_SEARCH_RESERVED_03" = 3
    CUBLASLT_SEARCH_RESERVED_04 "CUBLASLT_SEARCH_RESERVED_04" = 4
    CUBLASLT_SEARCH_RESERVED_05 "CUBLASLT_SEARCH_RESERVED_05" = 5
    CUBLASLT_SEARCH_RESERVED_06 "CUBLASLT_SEARCH_RESERVED_06" = 6
    CUBLASLT_SEARCH_RESERVED_07 "CUBLASLT_SEARCH_RESERVED_07" = 7
    CUBLASLT_SEARCH_RESERVED_08 "CUBLASLT_SEARCH_RESERVED_08" = 8
    CUBLASLT_SEARCH_RESERVED_09 "CUBLASLT_SEARCH_RESERVED_09" = 9

ctypedef enum cublasLtMatmulPreferenceAttributes_t "cublasLtMatmulPreferenceAttributes_t":
    CUBLASLT_MATMUL_PREF_SEARCH_MODE "CUBLASLT_MATMUL_PREF_SEARCH_MODE" = 0
    CUBLASLT_MATMUL_PREF_MAX_WORKSPACE_BYTES "CUBLASLT_MATMUL_PREF_MAX_WORKSPACE_BYTES" = 1
    CUBLASLT_MATMUL_PREF_REDUCTION_SCHEME_MASK "CUBLASLT_MATMUL_PREF_REDUCTION_SCHEME_MASK" = 3
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_A_BYTES "CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_A_BYTES" = 5
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_B_BYTES "CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_B_BYTES" = 6
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_C_BYTES "CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_C_BYTES" = 7
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_D_BYTES "CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_D_BYTES" = 8
    CUBLASLT_MATMUL_PREF_MAX_WAVES_COUNT "CUBLASLT_MATMUL_PREF_MAX_WAVES_COUNT" = 9
    CUBLASLT_MATMUL_PREF_IMPL_MASK "CUBLASLT_MATMUL_PREF_IMPL_MASK" = 12
    CUBLASLT_MATMUL_PREF_MATH_MODE_MASK "CUBLASLT_MATMUL_PREF_MATH_MODE_MASK" = 2
    CUBLASLT_MATMUL_PREF_GAUSSIAN_MODE_MASK "CUBLASLT_MATMUL_PREF_GAUSSIAN_MODE_MASK" = 4
    CUBLASLT_MATMUL_PREF_POINTER_MODE_MASK "CUBLASLT_MATMUL_PREF_POINTER_MODE_MASK" = 10
    CUBLASLT_MATMUL_PREF_EPILOGUE_MASK "CUBLASLT_MATMUL_PREF_EPILOGUE_MASK" = 11
    CUBLASLT_MATMUL_PREF_SM_COUNT_TARGET "CUBLASLT_MATMUL_PREF_SM_COUNT_TARGET" = 13

ctypedef enum cublasLtMatmulAlgoCapAttributes_t "cublasLtMatmulAlgoCapAttributes_t":
    CUBLASLT_ALGO_CAP_SPLITK_SUPPORT "CUBLASLT_ALGO_CAP_SPLITK_SUPPORT" = 0
    CUBLASLT_ALGO_CAP_REDUCTION_SCHEME_MASK "CUBLASLT_ALGO_CAP_REDUCTION_SCHEME_MASK" = 1
    CUBLASLT_ALGO_CAP_CTA_SWIZZLING_SUPPORT "CUBLASLT_ALGO_CAP_CTA_SWIZZLING_SUPPORT" = 2
    CUBLASLT_ALGO_CAP_STRIDED_BATCH_SUPPORT "CUBLASLT_ALGO_CAP_STRIDED_BATCH_SUPPORT" = 3
    CUBLASLT_ALGO_CAP_OUT_OF_PLACE_RESULT_SUPPORT "CUBLASLT_ALGO_CAP_OUT_OF_PLACE_RESULT_SUPPORT" = 4
    CUBLASLT_ALGO_CAP_UPLO_SUPPORT "CUBLASLT_ALGO_CAP_UPLO_SUPPORT" = 5
    CUBLASLT_ALGO_CAP_TILE_IDS "CUBLASLT_ALGO_CAP_TILE_IDS" = 6
    CUBLASLT_ALGO_CAP_CUSTOM_OPTION_MAX "CUBLASLT_ALGO_CAP_CUSTOM_OPTION_MAX" = 7
    CUBLASLT_ALGO_CAP_CUSTOM_MEMORY_ORDER "CUBLASLT_ALGO_CAP_CUSTOM_MEMORY_ORDER" = 10
    CUBLASLT_ALGO_CAP_POINTER_MODE_MASK "CUBLASLT_ALGO_CAP_POINTER_MODE_MASK" = 11
    CUBLASLT_ALGO_CAP_EPILOGUE_MASK "CUBLASLT_ALGO_CAP_EPILOGUE_MASK" = 12
    CUBLASLT_ALGO_CAP_STAGES_IDS "CUBLASLT_ALGO_CAP_STAGES_IDS" = 13
    CUBLASLT_ALGO_CAP_LD_NEGATIVE "CUBLASLT_ALGO_CAP_LD_NEGATIVE" = 14
    CUBLASLT_ALGO_CAP_NUMERICAL_IMPL_FLAGS "CUBLASLT_ALGO_CAP_NUMERICAL_IMPL_FLAGS" = 15
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_A_BYTES "CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_A_BYTES" = 16
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_B_BYTES "CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_B_BYTES" = 17
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_C_BYTES "CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_C_BYTES" = 18
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_D_BYTES "CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_D_BYTES" = 19
    CUBLASLT_ALGO_CAP_ATOMIC_SYNC "CUBLASLT_ALGO_CAP_ATOMIC_SYNC" = 20
    CUBLASLT_ALGO_CAP_MATHMODE_IMPL "CUBLASLT_ALGO_CAP_MATHMODE_IMPL" = 8
    CUBLASLT_ALGO_CAP_GAUSSIAN_IMPL "CUBLASLT_ALGO_CAP_GAUSSIAN_IMPL" = 9

ctypedef enum cublasLtMatmulAlgoConfigAttributes_t "cublasLtMatmulAlgoConfigAttributes_t":
    CUBLASLT_ALGO_CONFIG_ID "CUBLASLT_ALGO_CONFIG_ID" = 0
    CUBLASLT_ALGO_CONFIG_TILE_ID "CUBLASLT_ALGO_CONFIG_TILE_ID" = 1
    CUBLASLT_ALGO_CONFIG_SPLITK_NUM "CUBLASLT_ALGO_CONFIG_SPLITK_NUM" = 2
    CUBLASLT_ALGO_CONFIG_REDUCTION_SCHEME "CUBLASLT_ALGO_CONFIG_REDUCTION_SCHEME" = 3
    CUBLASLT_ALGO_CONFIG_CTA_SWIZZLING "CUBLASLT_ALGO_CONFIG_CTA_SWIZZLING" = 4
    CUBLASLT_ALGO_CONFIG_CUSTOM_OPTION "CUBLASLT_ALGO_CONFIG_CUSTOM_OPTION" = 5
    CUBLASLT_ALGO_CONFIG_STAGES_ID "CUBLASLT_ALGO_CONFIG_STAGES_ID" = 6
    CUBLASLT_ALGO_CONFIG_INNER_SHAPE_ID "CUBLASLT_ALGO_CONFIG_INNER_SHAPE_ID" = 7
    CUBLASLT_ALGO_CONFIG_CLUSTER_SHAPE_ID "CUBLASLT_ALGO_CONFIG_CLUSTER_SHAPE_ID" = 8

ctypedef enum cublasLtClusterShape_t "cublasLtClusterShape_t":
    CUBLASLT_CLUSTER_SHAPE_AUTO "CUBLASLT_CLUSTER_SHAPE_AUTO" = 0
    CUBLASLT_CLUSTER_SHAPE_1x1x1 "CUBLASLT_CLUSTER_SHAPE_1x1x1" = 2
    CUBLASLT_CLUSTER_SHAPE_2x1x1 "CUBLASLT_CLUSTER_SHAPE_2x1x1" = 3
    CUBLASLT_CLUSTER_SHAPE_4x1x1 "CUBLASLT_CLUSTER_SHAPE_4x1x1" = 4
    CUBLASLT_CLUSTER_SHAPE_1x2x1 "CUBLASLT_CLUSTER_SHAPE_1x2x1" = 5
    CUBLASLT_CLUSTER_SHAPE_2x2x1 "CUBLASLT_CLUSTER_SHAPE_2x2x1" = 6
    CUBLASLT_CLUSTER_SHAPE_4x2x1 "CUBLASLT_CLUSTER_SHAPE_4x2x1" = 7
    CUBLASLT_CLUSTER_SHAPE_1x4x1 "CUBLASLT_CLUSTER_SHAPE_1x4x1" = 8
    CUBLASLT_CLUSTER_SHAPE_2x4x1 "CUBLASLT_CLUSTER_SHAPE_2x4x1" = 9
    CUBLASLT_CLUSTER_SHAPE_4x4x1 "CUBLASLT_CLUSTER_SHAPE_4x4x1" = 10
    CUBLASLT_CLUSTER_SHAPE_8x1x1 "CUBLASLT_CLUSTER_SHAPE_8x1x1" = 11
    CUBLASLT_CLUSTER_SHAPE_1x8x1 "CUBLASLT_CLUSTER_SHAPE_1x8x1" = 12
    CUBLASLT_CLUSTER_SHAPE_8x2x1 "CUBLASLT_CLUSTER_SHAPE_8x2x1" = 13
    CUBLASLT_CLUSTER_SHAPE_2x8x1 "CUBLASLT_CLUSTER_SHAPE_2x8x1" = 14
    CUBLASLT_CLUSTER_SHAPE_16x1x1 "CUBLASLT_CLUSTER_SHAPE_16x1x1" = 15
    CUBLASLT_CLUSTER_SHAPE_1x16x1 "CUBLASLT_CLUSTER_SHAPE_1x16x1" = 16
    CUBLASLT_CLUSTER_SHAPE_3x1x1 "CUBLASLT_CLUSTER_SHAPE_3x1x1" = 17
    CUBLASLT_CLUSTER_SHAPE_5x1x1 "CUBLASLT_CLUSTER_SHAPE_5x1x1" = 18
    CUBLASLT_CLUSTER_SHAPE_6x1x1 "CUBLASLT_CLUSTER_SHAPE_6x1x1" = 19
    CUBLASLT_CLUSTER_SHAPE_7x1x1 "CUBLASLT_CLUSTER_SHAPE_7x1x1" = 20
    CUBLASLT_CLUSTER_SHAPE_9x1x1 "CUBLASLT_CLUSTER_SHAPE_9x1x1" = 21
    CUBLASLT_CLUSTER_SHAPE_10x1x1 "CUBLASLT_CLUSTER_SHAPE_10x1x1" = 22
    CUBLASLT_CLUSTER_SHAPE_11x1x1 "CUBLASLT_CLUSTER_SHAPE_11x1x1" = 23
    CUBLASLT_CLUSTER_SHAPE_12x1x1 "CUBLASLT_CLUSTER_SHAPE_12x1x1" = 24
    CUBLASLT_CLUSTER_SHAPE_13x1x1 "CUBLASLT_CLUSTER_SHAPE_13x1x1" = 25
    CUBLASLT_CLUSTER_SHAPE_14x1x1 "CUBLASLT_CLUSTER_SHAPE_14x1x1" = 26
    CUBLASLT_CLUSTER_SHAPE_15x1x1 "CUBLASLT_CLUSTER_SHAPE_15x1x1" = 27
    CUBLASLT_CLUSTER_SHAPE_3x2x1 "CUBLASLT_CLUSTER_SHAPE_3x2x1" = 28
    CUBLASLT_CLUSTER_SHAPE_5x2x1 "CUBLASLT_CLUSTER_SHAPE_5x2x1" = 29
    CUBLASLT_CLUSTER_SHAPE_6x2x1 "CUBLASLT_CLUSTER_SHAPE_6x2x1" = 30
    CUBLASLT_CLUSTER_SHAPE_7x2x1 "CUBLASLT_CLUSTER_SHAPE_7x2x1" = 31
    CUBLASLT_CLUSTER_SHAPE_1x3x1 "CUBLASLT_CLUSTER_SHAPE_1x3x1" = 32
    CUBLASLT_CLUSTER_SHAPE_2x3x1 "CUBLASLT_CLUSTER_SHAPE_2x3x1" = 33
    CUBLASLT_CLUSTER_SHAPE_3x3x1 "CUBLASLT_CLUSTER_SHAPE_3x3x1" = 34
    CUBLASLT_CLUSTER_SHAPE_4x3x1 "CUBLASLT_CLUSTER_SHAPE_4x3x1" = 35
    CUBLASLT_CLUSTER_SHAPE_5x3x1 "CUBLASLT_CLUSTER_SHAPE_5x3x1" = 36
    CUBLASLT_CLUSTER_SHAPE_3x4x1 "CUBLASLT_CLUSTER_SHAPE_3x4x1" = 37
    CUBLASLT_CLUSTER_SHAPE_1x5x1 "CUBLASLT_CLUSTER_SHAPE_1x5x1" = 38
    CUBLASLT_CLUSTER_SHAPE_2x5x1 "CUBLASLT_CLUSTER_SHAPE_2x5x1" = 39
    CUBLASLT_CLUSTER_SHAPE_3x5x1 "CUBLASLT_CLUSTER_SHAPE_3x5x1" = 40
    CUBLASLT_CLUSTER_SHAPE_1x6x1 "CUBLASLT_CLUSTER_SHAPE_1x6x1" = 41
    CUBLASLT_CLUSTER_SHAPE_2x6x1 "CUBLASLT_CLUSTER_SHAPE_2x6x1" = 42
    CUBLASLT_CLUSTER_SHAPE_1x7x1 "CUBLASLT_CLUSTER_SHAPE_1x7x1" = 43
    CUBLASLT_CLUSTER_SHAPE_2x7x1 "CUBLASLT_CLUSTER_SHAPE_2x7x1" = 44
    CUBLASLT_CLUSTER_SHAPE_1x9x1 "CUBLASLT_CLUSTER_SHAPE_1x9x1" = 45
    CUBLASLT_CLUSTER_SHAPE_1x10x1 "CUBLASLT_CLUSTER_SHAPE_1x10x1" = 46
    CUBLASLT_CLUSTER_SHAPE_1x11x1 "CUBLASLT_CLUSTER_SHAPE_1x11x1" = 47
    CUBLASLT_CLUSTER_SHAPE_1x12x1 "CUBLASLT_CLUSTER_SHAPE_1x12x1" = 48
    CUBLASLT_CLUSTER_SHAPE_1x13x1 "CUBLASLT_CLUSTER_SHAPE_1x13x1" = 49
    CUBLASLT_CLUSTER_SHAPE_1x14x1 "CUBLASLT_CLUSTER_SHAPE_1x14x1" = 50
    CUBLASLT_CLUSTER_SHAPE_1x15x1 "CUBLASLT_CLUSTER_SHAPE_1x15x1" = 51

ctypedef enum cublasLtMatmulInnerShape_t "cublasLtMatmulInnerShape_t":
    CUBLASLT_MATMUL_INNER_SHAPE_UNDEFINED "CUBLASLT_MATMUL_INNER_SHAPE_UNDEFINED" = 0
    CUBLASLT_MATMUL_INNER_SHAPE_MMA884 "CUBLASLT_MATMUL_INNER_SHAPE_MMA884" = 1
    CUBLASLT_MATMUL_INNER_SHAPE_MMA1684 "CUBLASLT_MATMUL_INNER_SHAPE_MMA1684" = 2
    CUBLASLT_MATMUL_INNER_SHAPE_MMA1688 "CUBLASLT_MATMUL_INNER_SHAPE_MMA1688" = 3
    CUBLASLT_MATMUL_INNER_SHAPE_MMA16816 "CUBLASLT_MATMUL_INNER_SHAPE_MMA16816" = 4

ctypedef enum cublasLtMatmulMatrixScale_t "cublasLtMatmulMatrixScale_t":
    CUBLASLT_MATMUL_MATRIX_SCALE_SCALAR_32F "CUBLASLT_MATMUL_MATRIX_SCALE_SCALAR_32F" = 0
    CUBLASLT_MATMUL_MATRIX_SCALE_VEC16_UE4M3 "CUBLASLT_MATMUL_MATRIX_SCALE_VEC16_UE4M3" = 1
    CUBLASLT_MATMUL_MATRIX_SCALE_VEC32_UE8M0 "CUBLASLT_MATMUL_MATRIX_SCALE_VEC32_UE8M0" = 2


# types
cdef extern from *:
    """
    #include <driver_types.h>
    #include <library_types.h>
    #include <cuComplex.h>
    """
    ctypedef void* cudaStream_t 'cudaStream_t'
    ctypedef int cudaDataType_t 'cudaDataType_t'
    ctypedef int cudaDataType 'cudaDataType'
    ctypedef int libraryPropertyType_t 'libraryPropertyType_t'
    ctypedef int libraryPropertyType 'libraryPropertyType'

    ctypedef struct cuComplex:
        pass
    ctypedef struct cuDoubleComplex:
        pass


ctypedef uint64_t cublasLtNumericalImplFlags_t 'cublasLtNumericalImplFlags_t'
ctypedef void* cublasLtHandle_t 'cublasLtHandle_t'
ctypedef void* cublasLtMatrixLayout_t 'cublasLtMatrixLayout_t'
ctypedef void* cublasLtMatmulDesc_t 'cublasLtMatmulDesc_t'
ctypedef void* cublasLtMatrixTransformDesc_t 'cublasLtMatrixTransformDesc_t'
ctypedef void* cublasLtMatmulPreference_t 'cublasLtMatmulPreference_t'
ctypedef struct cublasLtMatmulAlgo_t 'cublasLtMatmulAlgo_t':
    uint64_t data[8]
ctypedef void (*cublasLtLoggerCallback_t 'cublasLtLoggerCallback_t')(
    int logLevel,
    const char* functionName,
    const char* message
)
ctypedef struct cublasLtMatmulHeuristicResult_t 'cublasLtMatmulHeuristicResult_t':
    cublasLtMatmulAlgo_t algo
    size_t workspaceSize
    cublasStatus_t state
    float wavesCount
    int reserved[4]


###############################################################################
# Functions
###############################################################################

cdef cublasStatus_t cublasLtCreate(cublasLtHandle_t* lightHandle) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtDestroy(cublasLtHandle_t lightHandle) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef size_t cublasLtGetVersion() except?0 nogil
cdef size_t cublasLtGetCudartVersion() except?0 nogil
cdef cublasStatus_t cublasLtGetProperty(libraryPropertyType type, int* value) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmul(cublasLtHandle_t lightHandle, cublasLtMatmulDesc_t computeDesc, const void* alpha, const void* A, cublasLtMatrixLayout_t Adesc, const void* B, cublasLtMatrixLayout_t Bdesc, const void* beta, const void* C, cublasLtMatrixLayout_t Cdesc, void* D, cublasLtMatrixLayout_t Ddesc, const cublasLtMatmulAlgo_t* algo, void* workspace, size_t workspaceSizeInBytes, cudaStream_t stream) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixTransform(cublasLtHandle_t lightHandle, cublasLtMatrixTransformDesc_t transformDesc, const void* alpha, const void* A, cublasLtMatrixLayout_t Adesc, const void* beta, const void* B, cublasLtMatrixLayout_t Bdesc, void* C, cublasLtMatrixLayout_t Cdesc, cudaStream_t stream) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixLayoutCreate(cublasLtMatrixLayout_t* matLayout, cudaDataType type, uint64_t rows, uint64_t cols, int64_t ld) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixLayoutDestroy(cublasLtMatrixLayout_t matLayout) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixLayoutSetAttribute(cublasLtMatrixLayout_t matLayout, cublasLtMatrixLayoutAttribute_t attr, const void* buf, size_t sizeInBytes) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixLayoutGetAttribute(cublasLtMatrixLayout_t matLayout, cublasLtMatrixLayoutAttribute_t attr, void* buf, size_t sizeInBytes, size_t* sizeWritten) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulDescCreate(cublasLtMatmulDesc_t* matmulDesc, cublasComputeType_t computeType, cudaDataType_t scaleType) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulDescDestroy(cublasLtMatmulDesc_t matmulDesc) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulDescSetAttribute(cublasLtMatmulDesc_t matmulDesc, cublasLtMatmulDescAttributes_t attr, const void* buf, size_t sizeInBytes) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulDescGetAttribute(cublasLtMatmulDesc_t matmulDesc, cublasLtMatmulDescAttributes_t attr, void* buf, size_t sizeInBytes, size_t* sizeWritten) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixTransformDescCreate(cublasLtMatrixTransformDesc_t* transformDesc, cudaDataType scaleType) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixTransformDescDestroy(cublasLtMatrixTransformDesc_t transformDesc) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixTransformDescSetAttribute(cublasLtMatrixTransformDesc_t transformDesc, cublasLtMatrixTransformDescAttributes_t attr, const void* buf, size_t sizeInBytes) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatrixTransformDescGetAttribute(cublasLtMatrixTransformDesc_t transformDesc, cublasLtMatrixTransformDescAttributes_t attr, void* buf, size_t sizeInBytes, size_t* sizeWritten) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulPreferenceCreate(cublasLtMatmulPreference_t* pref) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulPreferenceDestroy(cublasLtMatmulPreference_t pref) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulPreferenceSetAttribute(cublasLtMatmulPreference_t pref, cublasLtMatmulPreferenceAttributes_t attr, const void* buf, size_t sizeInBytes) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulPreferenceGetAttribute(cublasLtMatmulPreference_t pref, cublasLtMatmulPreferenceAttributes_t attr, void* buf, size_t sizeInBytes, size_t* sizeWritten) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulAlgoGetHeuristic(cublasLtHandle_t lightHandle, cublasLtMatmulDesc_t operationDesc, cublasLtMatrixLayout_t Adesc, cublasLtMatrixLayout_t Bdesc, cublasLtMatrixLayout_t Cdesc, cublasLtMatrixLayout_t Ddesc, cublasLtMatmulPreference_t preference, int requestedAlgoCount, cublasLtMatmulHeuristicResult_t heuristicResultsArray[], int* returnAlgoCount) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulAlgoGetIds(cublasLtHandle_t lightHandle, cublasComputeType_t computeType, cudaDataType_t scaleType, cudaDataType_t Atype, cudaDataType_t Btype, cudaDataType_t Ctype, cudaDataType_t Dtype, int requestedAlgoCount, int algoIdsArray[], int* returnAlgoCount) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulAlgoInit(cublasLtHandle_t lightHandle, cublasComputeType_t computeType, cudaDataType_t scaleType, cudaDataType_t Atype, cudaDataType_t Btype, cudaDataType_t Ctype, cudaDataType_t Dtype, int algoId, cublasLtMatmulAlgo_t* algo) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulAlgoCheck(cublasLtHandle_t lightHandle, cublasLtMatmulDesc_t operationDesc, cublasLtMatrixLayout_t Adesc, cublasLtMatrixLayout_t Bdesc, cublasLtMatrixLayout_t Cdesc, cublasLtMatrixLayout_t Ddesc, const cublasLtMatmulAlgo_t* algo, cublasLtMatmulHeuristicResult_t* result) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulAlgoCapGetAttribute(const cublasLtMatmulAlgo_t* algo, cublasLtMatmulAlgoCapAttributes_t attr, void* buf, size_t sizeInBytes, size_t* sizeWritten) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulAlgoConfigSetAttribute(cublasLtMatmulAlgo_t* algo, cublasLtMatmulAlgoConfigAttributes_t attr, const void* buf, size_t sizeInBytes) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtMatmulAlgoConfigGetAttribute(const cublasLtMatmulAlgo_t* algo, cublasLtMatmulAlgoConfigAttributes_t attr, void* buf, size_t sizeInBytes, size_t* sizeWritten) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtLoggerSetCallback(cublasLtLoggerCallback_t callback) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtLoggerSetFile(FILE* file) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtLoggerOpenFile(const char* logFile) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtLoggerSetLevel(int level) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtLoggerSetMask(int mask) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtLoggerForceDisable() except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef const char* cublasLtGetStatusName(cublasStatus_t status) except?NULL nogil
cdef const char* cublasLtGetStatusString(cublasStatus_t status) except?NULL nogil
cdef cublasStatus_t cublasLtHeuristicsCacheGetCapacity(size_t* capacity) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef cublasStatus_t cublasLtHeuristicsCacheSetCapacity(size_t capacity) except?_CUBLASSTATUS_T_INTERNAL_LOADING_ERROR nogil
cdef unsigned cublasLtDisableCpuInstructionsSetMask(unsigned mask) except?0 nogil
